#region Copyright Syncfusion Inc. 2001 - 2005
//
//  Copyright Syncfusion Inc. 2001 - 2005. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.Collections;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Text;

using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Diagnostics;
using Syncfusion.Windows.Forms.Grid.Grouping;//.GridGroupingControl;
using Syncfusion.Grouping;
//using Syncfusion.ComponentModel;//.SyncfusionEventArgs;

namespace Advent.MxRules.Win.ExternalClient
{
	/// <summary>
	/// Summary description for CurrentCellEventTracer.
	/// </summary>
	public class CurrentCellEventTracer
	{
		SplitterControl _splitter;
		ListBox _output;
		bool _displayMouseMessage = false;
		bool traceDebug = false;

		public CurrentCellEventTracer(SplitterControl splitter, ListBox output)
		{
			this._splitter = splitter;
			splitter.PaneCreated += new SplitterPaneEventHandler(splitter_PaneCreated);
			splitter.PaneClosing += new SplitterPaneEventHandler(splitter_PaneClosing);
			WireGrid(splitter.ActivePane as GridControl);
			this._output = output;
		}

        public CurrentCellEventTracer()
        {
        }


		public void WireGrid(GridControl grid)
		{
			grid.CurrentCellAcceptedChanges += new System.ComponentModel.CancelEventHandler(grid_CurrentCellAcceptedChanges);
			grid.CurrentCellMoved += new Syncfusion.Windows.Forms.Grid.GridCurrentCellMovedEventHandler(grid_CurrentCellMoved);
			grid.CurrentCellActivateFailed += new Syncfusion.Windows.Forms.Grid.GridCurrentCellActivateFailedEventHandler(grid_CurrentCellActivateFailed);
			grid.CurrentCellActivated += new System.EventHandler(grid_CurrentCellActivated);
			grid.CurrentCellActivating += new GridCurrentCellActivatingEventHandler(grid_CurrentCellActivating);
			grid.CurrentCellChanged += new EventHandler(grid_CurrentCellChanged);
			grid.CurrentCellChanging += new CancelEventHandler(grid_CurrentCellChanging);
			grid.CurrentCellCloseDropDown += new PopupClosedEventHandler(grid_CurrentCellCloseDropDown);
			grid.CurrentCellConfirmChangesFailed += new EventHandler(grid_CurrentCellConfirmChangesFailed);
			grid.CurrentCellControlGotFocus += new ControlEventHandler(grid_CurrentCellControlGotFocus);
			grid.CurrentCellControlLostFocus += new ControlEventHandler(grid_CurrentCellControlLostFocus);
			grid.CurrentCellDeactivated += new GridCurrentCellDeactivatedEventHandler(grid_CurrentCellDeactivated);
			grid.CurrentCellDeactivateFailed += new EventHandler(grid_CurrentCellDeactivateFailed);
			grid.CurrentCellDeactivating += new CancelEventHandler(grid_CurrentCellDeactivating);
			grid.CurrentCellDeleting += new CancelEventHandler(grid_CurrentCellDeleting);
			grid.CurrentCellEditingComplete += new EventHandler(grid_CurrentCellEditingComplete);
			grid.CurrentCellInitializeControlText += new GridCurrentCellInitializeControlTextEventHandler(grid_CurrentCellInitializeControlText);
			grid.CurrentCellKeyDown += new KeyEventHandler(grid_CurrentCellKeyDown);
			grid.CurrentCellKeyPress +=new KeyPressEventHandler(grid_CurrentCellKeyPress);
			grid.CurrentCellKeyUp += new KeyEventHandler(grid_CurrentCellKeyUp);
			grid.CurrentCellMoved += new GridCurrentCellMovedEventHandler(grid_CurrentCellMoved);
			grid.CurrentCellMoveFailed += new GridCurrentCellMoveFailedEventHandler(grid_CurrentCellMoveFailed);
			grid.CurrentCellMoving += new GridCurrentCellMovingEventHandler(grid_CurrentCellMoving);
			grid.CurrentCellRejectedChanges += new EventHandler(grid_CurrentCellRejectedChanges);
			grid.CurrentCellShowedDropDown += new EventHandler(grid_CurrentCellShowedDropDown);
			grid.CurrentCellShowingDropDown += new GridCurrentCellShowingDropDownEventHandler(grid_CurrentCellShowingDropDown);
			grid.CurrentCellStartEditing += new CancelEventHandler(grid_CurrentCellStartEditing);
			grid.CurrentCellValidated += new EventHandler(grid_CurrentCellValidated);
			grid.CurrentCellValidateString += new GridCurrentCellValidateStringEventHandler(grid_CurrentCellValidateString);
			grid.CurrentCellValidating += new CancelEventHandler(grid_CurrentCellValidating);
			grid.CurrentCellControlDoubleClick += new ControlEventHandler(grid_CurrentCellControlDoubleClick);

			// Mouse events
			grid.CellButtonClicked += new GridCellButtonClickedEventHandler(grid_CellButtonClicked);
			grid.CellClick += new GridCellClickEventHandler(grid_CellClick);
			grid.CellDoubleClick += new GridCellClickEventHandler(grid_CellDoubleClick);
			grid.CellMouseDown += new GridCellMouseEventHandler(grid_CellMouseDown);
			grid.CellMouseHoverEnter += new GridCellMouseEventHandler(grid_CellMouseHoverEnter);
			grid.CellMouseHoverLeave += new GridCellMouseEventHandler(grid_CellMouseHoverLeave);
			grid.CellMouseUp += new GridCellMouseEventHandler(grid_CellMouseUp);
			grid.CheckBoxClick += new GridCellClickEventHandler(grid_CheckBoxClick);
			grid.PushButtonClick += new GridCellPushButtonClickEventHandler(grid_PushButtonClick);

			// Other events
			grid.Click += new EventHandler(grid_Click);
			grid.Deactivated += new EventHandler(grid_Deactivated);
			grid.DoubleClick += new EventHandler(grid_DoubleClick);
			grid.DragDrop += new DragEventHandler(grid_DragDrop);
			grid.DragEnter += new DragEventHandler(grid_DragEnter);
			grid.DragLeave += new EventHandler(grid_DragLeave);
			grid.DragOver += new DragEventHandler(grid_DragOver);
			grid.Enter += new EventHandler(grid_Enter);
			grid.GotFocus += new EventHandler(grid_GotFocus);
			grid.KeyDown += new KeyEventHandler(grid_KeyDown);
			grid.KeyPress += new KeyPressEventHandler(grid_KeyPress);
			grid.KeyUp += new KeyEventHandler(grid_KeyUp);
			grid.Layout += new LayoutEventHandler(grid_Layout);
			grid.Leave += new EventHandler(grid_Leave);
			grid.LostFocus += new EventHandler(grid_LostFocus);
			grid.MouseDown += new MouseEventHandler(grid_MouseDown);
			grid.MouseUp += new MouseEventHandler(grid_MouseUp);
			grid.MouseEnter += new EventHandler(grid_MouseEnter);
			grid.MouseLeave	+= new EventHandler(grid_MouseLeave);
			grid.QueryCanOleDragRange += new GridQueryCanOleDragRangeEventHandler(grid_QueryCanOleDragRange);
			grid.QueryNextCurrentCellPosition += new GridQueryNextCurrentCellPositionEventHandler(grid_QueryNextCurrentCellPosition);
			grid.QueryOleDataSourceData += new GridQueryOleDataSourceDataEventHandler(grid_QueryOleDataSourceData);
			grid.ResizingColumns += new GridResizingColumnsEventHandler(grid_ResizingColumns);
			grid.ResizingRows += new GridResizingRowsEventHandler(grid_ResizingRows);
			grid.ScrollInfoChanged += new EventHandler(grid_ScrollInfoChanged);
			grid.SelectionDragging += new GridSelectionDragEventHandler(grid_SelectionDragging);
			grid.SelectionDragged += new GridSelectionDragEventHandler(grid_SelectionDragged);
			grid.StartAutoScrolling += new StartAutoScrollingEventHandler(grid_StartAutoScrolling);
			grid.Validated += new EventHandler(grid_Validated);
			grid.Validating += new CancelEventHandler(grid_Validating);
			grid.WrapCellNextControlInForm += new GridWrapCellNextControlInFormEventHandler(grid_WrapCellNextControlInForm);
		}


        public void WireGridEvents(GridGroupingControl grGrid)
        {
            grGrid.SourceListRecordChanged += new Syncfusion.Grouping.RecordChangedEventHandler(this.gridRuleAlerts_SourceListRecordChanged);
            grGrid.TableControlKeyDown += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlKeyEventHandler(this.gridRuleAlerts_TableControlKeyDown);
            grGrid.CurrentRecordManagerReset += new Syncfusion.Grouping.TableEventHandler(this.gridRuleAlerts_CurrentRecordManagerReset);
            grGrid.TableControlCurrentCellShowingDropDown += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCurrentCellShowingDropDownEventHandler(this.gridRuleAlerts_TableControlCurrentCellShowingDropDown);
            grGrid.CausesValidationChanged += new System.EventHandler(this.gridRuleAlerts_CausesValidationChanged);
            grGrid.GroupExpanding += new Syncfusion.Grouping.GroupEventHandler(this.gridRuleAlerts_GroupExpanding);
            grGrid.TableControlCellMouseMove += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellMouseEventHandler(this.gridRuleAlerts_TableControlCellMouseMove);
            grGrid.TableControlQueryAllowSortColumn += new Syncfusion.Windows.Forms.Grid.Grouping.GridQueryAllowSortColumnEventHandler(this.gridRuleAlerts_TableControlQueryAllowSortColumn);
            grGrid.TableControlVScrollPixelPosChanged += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlScrollPositionChangedEventHandler(this.gridRuleAlerts_TableControlVScrollPixelPosChanged);
            grGrid.TableControlCurrentCellControlGotFocus += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlControlEventHandler(this.gridRuleAlerts_TableControlCurrentCellControlGotFocus);
            grGrid.RecordCollapsing += new Syncfusion.Grouping.RecordEventHandler(this.gridRuleAlerts_RecordCollapsing);
            grGrid.TableControlCellCursor += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellCursorEventHandler(this.gridRuleAlerts_TableControlCellCursor);
            grGrid.ContextMenuStripChanged += new System.EventHandler(this.gridRuleAlerts_ContextMenuStripChanged);
            grGrid.TableControlCurrentCellShowedDropDown += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlEventHandler(this.gridRuleAlerts_TableControlCurrentCellShowedDropDown);
            grGrid.TableControlCurrentCellEditingComplete += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlEventHandler(this.gridRuleAlerts_TableControlCurrentCellEditingComplete);
            grGrid.TableControlDrawCellDisplayText += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlDrawCellDisplayTextEventHandler(this.gridRuleAlerts_TableControlDrawCellDisplayText);
            grGrid.RecordValueChanged += new Syncfusion.Grouping.RecordValueChangedEventHandler(this.gridRuleAlerts_RecordValueChanged);
            grGrid.TableControlQueryAllowGroupByColumn += new Syncfusion.Windows.Forms.Grid.Grouping.GridQueryAllowGroupByColumnEventHandler(this.gridRuleAlerts_TableControlQueryAllowGroupByColumn);
            grGrid.GroupAdded += new Syncfusion.Grouping.GroupEventHandler(this.gridRuleAlerts_GroupAdded);
            grGrid.GroupCollapsed += new Syncfusion.Grouping.GroupEventHandler(this.gridRuleAlerts_GroupCollapsed);
            grGrid.TableControlPrepareViewStyleInfo += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlPrepareViewStyleInfoEventHandler(this.gridRuleAlerts_TableControlPrepareViewStyleInfo);
            //TODO: 1
            //grGrid.TableControlDrawCellButtonBackground += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlDrawCellButtonBackgroundEventHandler(this.gridRuleAlerts_TableControlDrawCellButtonBackground);
            grGrid.SelectedRecordsChanging += new Syncfusion.Grouping.SelectedRecordsChangedEventHandler(this.gridRuleAlerts_SelectedRecordsChanging);
            grGrid.TableControlDrawCellFrameAppearance += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlDrawCellBackgroundEventHandler(this.gridRuleAlerts_TableControlDrawCellFrameAppearance);
            grGrid.ChangeUICues += new System.Windows.Forms.UICuesEventHandler(this.gridRuleAlerts_ChangeUICues);
            grGrid.SaveCellFormattedText += new Syncfusion.Windows.Forms.Grid.GridCellTextEventHandler(this.gridRuleAlerts_SaveCellFormattedText);
            grGrid.TableControlHScrollPixelPosChanging += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlScrollPositionChangingEventHandler(this.gridRuleAlerts_TableControlHScrollPixelPosChanging);
            grGrid.TableControlCurrentCellAcceptedChanges += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCancelEventHandler(this.gridRuleAlerts_TableControlCurrentCellAcceptedChanges);
            grGrid.TableControlPushButtonClick += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellPushButtonClickEventHandler(this.gridRuleAlerts_TableControlPushButtonClick);
            grGrid.ClientSizeChanged += new System.EventHandler(this.gridRuleAlerts_ClientSizeChanged);
            grGrid.TableControlQueryAllowArrowKeyNavigateTo += new Syncfusion.Windows.Forms.Grid.Grouping.GridQueryAllowArrowKeyNavigateToEventHandler(this.gridRuleAlerts_TableControlQueryAllowArrowKeyNavigateTo);
            grGrid.RecordDeleted += new Syncfusion.Grouping.RecordEventHandler(this.gridRuleAlerts_RecordDeleted);
            grGrid.GroupRemoving += new Syncfusion.Grouping.GroupEventHandler(this.gridRuleAlerts_GroupRemoving);
            grGrid.TextChanged += new System.EventHandler(this.gridRuleAlerts_TextChanged);
            grGrid.TableControlLeftColChanged += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlRowColIndexChangedEventHandler(this.gridRuleAlerts_TableControlLeftColChanged);
            grGrid.TableControlCurrentCellValidateString += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCurrentCellValidateStringEventHandler(this.gridRuleAlerts_TableControlCurrentCellValidateString);
            grGrid.TableControlCurrentCellConfirmChangesFailed += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlEventHandler(this.gridRuleAlerts_TableControlCurrentCellConfirmChangesFailed);
            grGrid.DoubleClick += new System.EventHandler(this.gridRuleAlerts_DoubleClick);
            //TODO: 2
            //grGrid.SelectedRecordsChanged += new Syncfusion.Grouping.SelectedRecordsChangedEventHandler(this.gridRuleAlerts_SelectRecordChanged);
            grGrid.CurrentRecordContextChange += new Syncfusion.Grouping.CurrentRecordContextChangeEventHandler(this.gridRuleAlerts_CurrentRecordContextChange);
            grGrid.TableControlCurrentCellActivated += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlEventHandler(this.gridRuleAlerts_TableControlCurrentCellActivated);
            grGrid.KeyDown += new System.Windows.Forms.KeyEventHandler(this.gridRuleAlerts_KeyDown);
            grGrid.RecordCollapsed += new Syncfusion.Grouping.RecordEventHandler(this.gridRuleAlerts_RecordCollapsed);
            grGrid.DragDrop += new System.Windows.Forms.DragEventHandler(this.gridRuleAlerts_DragDrop);
            grGrid.MouseCaptureChanged += new System.EventHandler(this.gridRuleAlerts_MouseCaptureChanged);
            grGrid.MouseDoubleClick += new System.Windows.Forms.MouseEventHandler(this.gridRuleAlerts_MouseDoubleClick);
            grGrid.SourceListListChangedCompleted += new Syncfusion.Grouping.TableListChangedEventHandler(this.gridRuleAlerts_SourceListListChangedCompleted);
            grGrid.TableControlCurrentCellActivating += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCurrentCellActivatingEventHandler(this.gridRuleAlerts_TableControlCurrentCellActivating);
            grGrid.TableControlCellDoubleClick += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventHandler(this.gridRuleAlerts_TableControlCellDoubleClick);
            grGrid.MarginChanged += new System.EventHandler(this.gridRuleAlerts_MarginChanged);
            grGrid.GroupExpanded += new Syncfusion.Grouping.GroupEventHandler(this.gridRuleAlerts_GroupExpanded);
            grGrid.TableControlResizingColumns += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlResizingColumnsEventHandler(this.gridRuleAlerts_TableControlResizingColumns);
            grGrid.TableControlVScrollPixelPosChanging += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlScrollPositionChangingEventHandler(this.gridRuleAlerts_TableControlVScrollPixelPosChanging);
            grGrid.TableControlQueryNextCurrentCellPosition += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlQueryNextCurrentCellPositionEventHandler(this.gridRuleAlerts_TableControlQueryNextCurrentCellPosition);
            grGrid.TableControlHScrollPixelPosChanged += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlScrollPositionChangedEventHandler(this.gridRuleAlerts_TableControlHScrollPixelPosChanged);
            grGrid.Leave += new System.EventHandler(this.gridRuleAlerts_Leave);
            grGrid.MouseClick += new System.Windows.Forms.MouseEventHandler(this.gridRuleAlerts_MouseClick);
            grGrid.ControlAdded += new System.Windows.Forms.ControlEventHandler(this.gridRuleAlerts_ControlAdded);
            grGrid.TableControlCurrentCellMoveFailed += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCurrentCellMoveFailedEventHandler(this.gridRuleAlerts_TableControlCurrentCellMoveFailed);
            //TODO:3
            //grGrid.TableControlCurrentCellCloseDropDown += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlPopupClosedEventHandler(this.gridRuleAlert_CurrentCellCloseDropDown);
            grGrid.TableControlDrawCellBackground += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlDrawCellBackgroundEventHandler(this.gridRuleAlerts_TableControlDrawCellBackground);
            grGrid.TableControlDrawCell += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlDrawCellEventHandler(this.gridRuleAlerts_TableControlDrawCell);
            grGrid.TableControlLeftColChanging += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlRowColIndexChangingEventHandler(this.gridRuleAlerts_TableControlLeftColChanging);
            grGrid.LocationChanged += new System.EventHandler(this.gridRuleAlerts_LocationChanged);
            grGrid.TableControlCurrentCellDeactivated += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCurrentCellDeactivatedEventHandler(this.gridRuleAlerts_TableControlCurrentCellDeactivated);
            grGrid.TableControlTopRowChanged += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlRowColIndexChangedEventHandler(this.gridRuleAlerts_TableControlTopRowChanged);
            grGrid.TableControlCellMouseHover += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellMouseEventHandler(this.gridRuleAlerts_TableControlCellMouseHover);
            grGrid.Validated += new System.EventHandler(this.gridRuleAlerts_Validated);
            grGrid.TableControlResizingRows += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlResizingRowsEventHandler(this.gridRuleAlerts_TableControlResizingRows);
            grGrid.TableControlCurrentCellKeyDown += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlKeyEventHandler(this.gridRuleAlerts_TableControlCurrentCellKeyDown);
            grGrid.TableControlCurrentCellValidating += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCancelEventHandler(this.gridRuleAlerts_TableControlCurrentCellValidating);
            grGrid.QueryContinueDrag += new System.Windows.Forms.QueryContinueDragEventHandler(this.gridRuleAlerts_QueryContinueDrag);
            grGrid.RecordExpanding += new Syncfusion.Grouping.RecordEventHandler(this.gridRuleAlerts_RecordExpanding);
            grGrid.TableControlTopRowChanging += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlRowColIndexChangingEventHandler(this.gridRuleAlerts_TableControlTopRowChanging);
            grGrid.TableControlQueryAllowDragColumn += new Syncfusion.Windows.Forms.Grid.Grouping.GridQueryAllowDragColumnEventHandler(this.gridRuleAlerts_TableControlQueryAllowDragColumn);
            grGrid.TableControlCurrentCellMoved += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCurrentCellMovedEventHandler(this.gridRuleAlerts_TableControlCurrentCellMoved);
            grGrid.QueryRecordMeetsFilterCriteria += new Syncfusion.Grouping.QueryRecordMeetsFilterCriteriaEventHandler(this.gridRuleAlerts_QueryRecordMeetsFilterCriteria);
            grGrid.TableControlCurrentCellRejectedChanges += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlEventHandler(this.gridRuleAlerts_TableControlCurrentCellRejectedChanges);
            grGrid.QueryCellText += new Syncfusion.Windows.Forms.Grid.GridCellTextEventHandler(this.gridRuleAlerts_QueryCellText);
            grGrid.TableControlCellClick += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventHandler(this.gridRuleAlerts_TableControlCellClick);
            grGrid.TableSourceListChanged += new Syncfusion.Grouping.TableEventHandler(this.gridRuleAlerts_TableSourceListChanged);
            grGrid.TabIndexChanged += new System.EventHandler(this.gridRuleAlerts_TabIndexChanged);
            grGrid.TableControlMoveCurrentCellDirection += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlMoveCurrentCellDirectionEventHandler(this.gridRuleAlerts_TableControlMoveCurrentCellDirection);
            grGrid.TableControlCurrentCellChanging += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCancelEventHandler(this.gridRuleAlerts_TableControlCurrentCellChanging);
            grGrid.TableControlCurrentCellKeyPress += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlKeyPressEventHandler(this.gridRuleAlerts_TableControlCurrentCellKeyPress);
            grGrid.TableControlCellMouseHoverEnter += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellMouseEventHandler(this.gridRuleAlerts_TableControlCellMouseHoverEnter);
            grGrid.ControlRemoved += new System.Windows.Forms.ControlEventHandler(this.gridRuleAlerts_ControlRemoved);
            grGrid.VisibleChanged += new System.EventHandler(this.gridRuleAlerts_VisibleChanged);
            grGrid.SourceListListChanged += new Syncfusion.Grouping.TableListChangedEventHandler(this.gridRuleAlerts_SourceListListChanged);
            grGrid.TableControlDrawCurrentCellBorder += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlDrawCurrentCellBorderEventHandler(this.gridRuleAlerts_TableControlDrawCurrentCellBorder);
            //TODO: 4
            //grGrid.TableControlCurrentCellChanged += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlEventHandler(this.gridRuleAlert_lCurrentCellChanged);
            grGrid.TableControlMouseWheel += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlMouseEventHandler(this.gridRuleAlerts_TableControlMouseWheel);
            grGrid.TableControlKeyPress += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlKeyPressEventHandler(this.gridRuleAlerts_TableControlKeyPress);
            grGrid.Layout += new System.Windows.Forms.LayoutEventHandler(this.gridRuleAlerts_Layout);
            grGrid.DisplayElementChanged += new Syncfusion.Grouping.DisplayElementChangedEventHandler(this.gridRuleAlerts_DisplayElementChanged);
            grGrid.TableControlDrawCellButton += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlDrawCellButtonEventHandler(this.gridRuleAlerts_TableControlDrawCellButton);
            grGrid.TableControlCellHitTest += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellHitTestEventHandler(this.gridRuleAlerts_TableControlCellHitTest);
            grGrid.CategorizedRecords += new Syncfusion.Grouping.TableEventHandler(this.gridRuleAlerts_CategorizedRecords);
            grGrid.TableControlWrapCellNextControlInForm += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlWrapCellNextControlInFormEventHandler(this.gridRuleAlerts_TableControlWrapCellNextControlInForm);
            grGrid.DockChanged += new System.EventHandler(this.gridRuleAlerts_DockChanged);
            grGrid.QueryCoveredRange += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableQueryCoveredRangeEventHandler(this.gridRuleAlerts_QueryCoveredRange);
            grGrid.KeyUp += new System.Windows.Forms.KeyEventHandler(this.gridRuleAlerts_KeyUp);
            grGrid.SourceListRecordChanging += new Syncfusion.Grouping.RecordChangedEventHandler(this.gridRuleAlerts_SourceListRecordChanging);
            grGrid.TableControlMouseDown += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlMouseEventHandler(this.gridRuleAlerts_TableControlMouseDown);
            grGrid.TableControlCellMouseHoverLeave += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellMouseEventHandler(this.gridRuleAlerts_TableControlCellMouseHoverLeave);
            grGrid.QueryCellFormattedText += new Syncfusion.Windows.Forms.Grid.GridCellTextEventHandler(this.gridRuleAlerts_QueryCellFormattedText);
            grGrid.TableControlCurrentCellStartEditing += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCancelEventHandler(this.gridRuleAlerts_TableControlCurrentCellStartEditing);
            grGrid.TableControlCurrentCellDeactivateFailed += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlEventHandler(this.gridRuleAlerts_TableControlCurrentCellDeactivateFailed);
            grGrid.SaveValue += new Syncfusion.Grouping.FieldValueEventHandler(this.gridRuleAlerts_SaveValue);
            grGrid.TableControlCurrentCellErrorMessage += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCurrentCellErrorMessageEventHandler(this.gridRuleAlerts_TableControlCurrentCellErrorMessage);
            grGrid.SortedItemsInGroup += new Syncfusion.Grouping.GroupEventHandler(this.gridRuleAlerts_SortedItemsInGroup);
            //TODO: 5
            //grGrid.TableControlCurrentCellControlDoubleClick += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlControlEventHandler(this.gridRuleAlerts_TableControlCurrentCellControlDoubleClick);
            grGrid.QueryCellStyleInfo += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventHandler(this.gridRuleAlerts_QueryCellStyleInfo);
            grGrid.CategorizingRecords += new Syncfusion.Grouping.TableEventHandler(this.gridRuleAlerts_CategorizingRecords);
            grGrid.TabStopChanged += new System.EventHandler(this.gridRuleAlerts_TabStopChanged);
            grGrid.TableControlCurrentCellControlKeyMessage += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCurrentCellControlKeyMessageEventHandler(this.gridRuleAlerts_TableControlCurrentCellControlKeyMessage);
            grGrid.TableControlCurrentCellKeyUp += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlKeyEventHandler(this.gridRuleAlerts_TableControlCurrentCellKeyUp);
            grGrid.RecordExpanded += new Syncfusion.Grouping.RecordEventHandler(this.gridRuleAlerts_RecordExpanded);
            grGrid.TableControlCellMouseUp += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellMouseEventHandler(this.gridRuleAlerts_TableControlCellMouseUp);
            grGrid.Validating += new System.ComponentModel.CancelEventHandler(this.gridRuleAlerts_Validating);
            grGrid.DisplayElementChanging += new Syncfusion.Grouping.DisplayElementChangingEventHandler(this.gridRuleAlerts_DisplayElementChanging);
            grGrid.TableControlCellDrawn += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlDrawCellEventHandler(this.gridRuleAlerts_TableControlCellDrawn);
            grGrid.RecordValueChanging += new Syncfusion.Grouping.RecordValueChangingEventHandler(this.gridRuleAlerts_RecordValueChanging);
            grGrid.TableControlCurrentCellMoving += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCurrentCellMovingEventHandler(this.gridRuleAlerts_TableControlCurrentCellMoving);
            grGrid.TableControlScrollTipFeedback += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlScrollTipFeedbackEventHandler(this.gridRuleAlerts_TableControlScrollTipFeedback);
            grGrid.GroupCollapsing += new Syncfusion.Grouping.GroupEventHandler(this.gridRuleAlerts_GroupCollapsing);
            grGrid.BindingContextChanged += new System.EventHandler(this.gridRuleAlerts_BindingContextChanged);
            grGrid.TableControlCellButtonClicked += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellButtonClickedEventHandler(this.gridRuleAlerts_TableControlCellButtonClicked);
            grGrid.TableControlCurrentCellActivateFailed += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCurrentCellActivateFailedEventHandler(this.gridRuleAlerts_TableControlCurrentCellActivateFailed);
            grGrid.TableControlCurrentCellDeleting += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCancelEventHandler(this.gridRuleAlerts_TableControlCurrentCellDeleting);
            grGrid.Click += new System.EventHandler(this.gridRuleAlerts_Click);
            grGrid.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.gridRuleAlerts_KeyPress);
            grGrid.SaveCellText += new Syncfusion.Windows.Forms.Grid.GridCellTextEventHandler(this.gridRuleAlerts_SaveCellText);
            grGrid.TableControlCurrentCellControlLostFocus += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlControlEventHandler(this.gridRuleAlerts_TableControlCurrentCellControlLostFocus);
            grGrid.TableControlCurrentCellInitializeControlText += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCurrentCellInitializeControlTextEventHandler(this.gridRuleAlerts_TableControlCurrentCellInitializeControlText);
            grGrid.TableControlCurrentCellDeactivating += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCancelEventHandler(this.gridRuleAlerts_TableControlCurrentCellDeactivating);
            grGrid.TableControlCellCancelMode += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellMouseEventHandler(this.gridRuleAlerts_TableControlCellCancelMode);
            grGrid.TableControlCellMouseDown += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellMouseEventHandler(this.gridRuleAlerts_TableControlCellMouseDown);
            grGrid.QueryValue += new Syncfusion.Grouping.FieldValueEventHandler(this.gridRuleAlerts_QueryValue);
            grGrid.TableControlKeyUp += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlKeyEventHandler(this.gridRuleAlerts_TableControlKeyUp);
            grGrid.TableControlCurrentCellValidated += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlEventHandler(this.gridRuleAlerts_TableControlCurrentCellValidated);
            grGrid.CursorChanged += new System.EventHandler(this.gridRuleAlerts_CursorChanged);
            grGrid.TableControlQueryScrollCellInView += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlQueryScrollCellInViewEventHandler(this.gridRuleAlerts_TableControlQueryScrollCellInView);
            grGrid.TableControlCheckBoxClick += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventHandler(this.gridRuleAlerts_TableControlCheckBoxClick);
        }


		public void UnwireGrid(GridControl grid)
		{
			grid.CurrentCellAcceptedChanges -= new System.ComponentModel.CancelEventHandler(grid_CurrentCellAcceptedChanges);
			grid.CurrentCellMoved -= new Syncfusion.Windows.Forms.Grid.GridCurrentCellMovedEventHandler(grid_CurrentCellMoved);
			grid.CurrentCellActivateFailed -= new Syncfusion.Windows.Forms.Grid.GridCurrentCellActivateFailedEventHandler(grid_CurrentCellActivateFailed);
			grid.CurrentCellActivated -= new System.EventHandler(grid_CurrentCellActivated);
			grid.CurrentCellActivating -= new GridCurrentCellActivatingEventHandler(grid_CurrentCellActivating);
			grid.CurrentCellChanged -= new EventHandler(grid_CurrentCellChanged);
			grid.CurrentCellChanging -= new CancelEventHandler(grid_CurrentCellChanging);
			grid.CurrentCellCloseDropDown -= new PopupClosedEventHandler(grid_CurrentCellCloseDropDown);
			grid.CurrentCellConfirmChangesFailed -= new EventHandler(grid_CurrentCellConfirmChangesFailed);
			grid.CurrentCellControlGotFocus -= new ControlEventHandler(grid_CurrentCellControlGotFocus);
			grid.CurrentCellControlLostFocus -= new ControlEventHandler(grid_CurrentCellControlLostFocus);
			grid.CurrentCellDeactivated -= new GridCurrentCellDeactivatedEventHandler(grid_CurrentCellDeactivated);
			grid.CurrentCellDeactivateFailed -= new EventHandler(grid_CurrentCellDeactivateFailed);
			grid.CurrentCellDeactivating -= new CancelEventHandler(grid_CurrentCellDeactivating);
			grid.CurrentCellDeleting -= new CancelEventHandler(grid_CurrentCellDeleting);
			grid.CurrentCellEditingComplete -= new EventHandler(grid_CurrentCellEditingComplete);
			grid.CurrentCellInitializeControlText -= new GridCurrentCellInitializeControlTextEventHandler(grid_CurrentCellInitializeControlText);
			grid.CurrentCellKeyDown -= new KeyEventHandler(grid_CurrentCellKeyDown);
			grid.CurrentCellKeyPress -=new KeyPressEventHandler(grid_CurrentCellKeyPress);
			grid.CurrentCellKeyUp -= new KeyEventHandler(grid_CurrentCellKeyUp);
			grid.CurrentCellMoved -= new GridCurrentCellMovedEventHandler(grid_CurrentCellMoved);
			grid.CurrentCellMoveFailed -= new GridCurrentCellMoveFailedEventHandler(grid_CurrentCellMoveFailed);
			grid.CurrentCellMoving -= new GridCurrentCellMovingEventHandler(grid_CurrentCellMoving);
			grid.CurrentCellRejectedChanges -= new EventHandler(grid_CurrentCellRejectedChanges);
			grid.CurrentCellShowedDropDown -= new EventHandler(grid_CurrentCellShowedDropDown);
			grid.CurrentCellShowingDropDown -= new GridCurrentCellShowingDropDownEventHandler(grid_CurrentCellShowingDropDown);
			grid.CurrentCellStartEditing -= new CancelEventHandler(grid_CurrentCellStartEditing);
			grid.CurrentCellValidated -= new EventHandler(grid_CurrentCellValidated);
			grid.CurrentCellValidateString -= new GridCurrentCellValidateStringEventHandler(grid_CurrentCellValidateString);
			grid.CurrentCellControlDoubleClick -= new ControlEventHandler(grid_CurrentCellControlDoubleClick);

			grid.CellButtonClicked -= new GridCellButtonClickedEventHandler(grid_CellButtonClicked);
			grid.CellClick -= new GridCellClickEventHandler(grid_CellClick);
			grid.CellDoubleClick -= new GridCellClickEventHandler(grid_CellDoubleClick);
			grid.CellMouseDown -= new GridCellMouseEventHandler(grid_CellMouseDown);
			grid.CellMouseHoverEnter -= new GridCellMouseEventHandler(grid_CellMouseHoverEnter);
			grid.CellMouseHoverLeave -= new GridCellMouseEventHandler(grid_CellMouseHoverLeave);
			grid.CellMouseUp -= new GridCellMouseEventHandler(grid_CellMouseUp);
			grid.CheckBoxClick -= new GridCellClickEventHandler(grid_CheckBoxClick);
			grid.PushButtonClick -= new GridCellPushButtonClickEventHandler(grid_PushButtonClick);
		
			// Other events
			grid.Click -= new EventHandler(grid_Click);
			grid.Deactivated -= new EventHandler(grid_Deactivated);
			grid.DoubleClick -= new EventHandler(grid_DoubleClick);
			grid.DragDrop -= new DragEventHandler(grid_DragDrop);
			grid.DragEnter -= new DragEventHandler(grid_DragEnter);
			grid.DragLeave -= new EventHandler(grid_DragLeave);
			grid.DragOver -= new DragEventHandler(grid_DragOver);
			grid.Enter -= new EventHandler(grid_Enter);
			grid.GotFocus -= new EventHandler(grid_GotFocus);
			grid.KeyDown -= new KeyEventHandler(grid_KeyDown);
			grid.KeyPress -= new KeyPressEventHandler(grid_KeyPress);
			grid.KeyUp -= new KeyEventHandler(grid_KeyUp);
			grid.Layout -= new LayoutEventHandler(grid_Layout);
			grid.Leave -= new EventHandler(grid_Leave);
			grid.LostFocus -= new EventHandler(grid_LostFocus);
			grid.MouseDown -= new MouseEventHandler(grid_MouseDown);
			grid.MouseUp -= new MouseEventHandler(grid_MouseUp);
			grid.MouseEnter -= new EventHandler(grid_MouseEnter);
			grid.MouseLeave	-= new EventHandler(grid_MouseLeave);
			grid.QueryCanOleDragRange -= new GridQueryCanOleDragRangeEventHandler(grid_QueryCanOleDragRange);
			grid.QueryNextCurrentCellPosition -= new GridQueryNextCurrentCellPositionEventHandler(grid_QueryNextCurrentCellPosition);
			grid.QueryOleDataSourceData -= new GridQueryOleDataSourceDataEventHandler(grid_QueryOleDataSourceData);
			grid.ResizingColumns -= new GridResizingColumnsEventHandler(grid_ResizingColumns);
			grid.ResizingRows -= new GridResizingRowsEventHandler(grid_ResizingRows);
			grid.ScrollInfoChanged -= new EventHandler(grid_ScrollInfoChanged);
			grid.SelectionDragging -= new GridSelectionDragEventHandler(grid_SelectionDragging);
			grid.SelectionDragged -= new GridSelectionDragEventHandler(grid_SelectionDragged);
			grid.StartAutoScrolling -= new StartAutoScrollingEventHandler(grid_StartAutoScrolling);
			grid.Validated -= new EventHandler(grid_Validated);
			grid.Validating -= new CancelEventHandler(grid_Validating);
			grid.WrapCellNextControlInForm -= new GridWrapCellNextControlInFormEventHandler(grid_WrapCellNextControlInForm);
		}

		private void splitter_PaneCreated(object sender, SplitterPaneEventArgs e)
		{
			GridControl grid = e.Control as GridControl;
			WireGrid(grid);
		}

		private void splitter_PaneClosing(object sender, SplitterPaneEventArgs e)
		{
			GridControl grid = e.Control as GridControl;
			UnwireGrid(grid);
		}

		string lastLine = "";

		string GetInfo(string name)
		{
			GridControl grid = this._splitter.ActivePane as GridControl;
			string s = "";
			if (grid != null)
			{
				if (grid.CurrentCell.HasCurrentCell)
				{
					GridCurrentCell cc = grid.CurrentCell;
					GridCellRendererBase renderer = cc.Renderer;
					GridStyleInfo style = grid[cc.RowIndex, cc.ColIndex];

					string ct = "";
					if (renderer.HasControlText)
						ct = " ControlText: " + renderer.ControlText;
					string cv = "";
					if (renderer.HasControlValue)
					{
						if (renderer.ControlValue != null)
							ct = " ControlValue: " + renderer.ControlValue.ToString();
						else
							ct = " ControlValue: null";
					}
					string st = style.Text;
					string sv = "";
					if (style.CellValue != null)
						sv = style.CellValue.ToString();

					s = string.Format("{0}{1} {2}\"{3}\", \"{4}\", StyleText: \"{5}\", StyleValue: \"{6}\" ",
						cc.IsModified ? "*" : "",
						name,
						grid.CurrentCell.RangeInfo, 
						ct,
						cv,
						st, 
						sv
						);
				}
				else
				{
					s = name; 
				}
			}	
			return s;
		}

		bool _enabled = false;

		public bool Enabled
		{
			get
			{
				return _enabled;
			}
			set
			{
				_enabled = value;
			}
		}

		public bool DisplayMouseMessages
		{
			get
			{
				return _displayMouseMessage;
			}
			set
			{
				_displayMouseMessage = value;
			}
		}

		void AppendOutput(string name, EventArgs e)
		{
            //if (!Enabled)
            //    return;

            //string s = "";
            //if (name.StartsWith("CurrentCell"))
            //{
            //    //name = name.Substring("CurrentCell".Length);

            //    s = GetInfo(name) + " " + e.ToString();
            //}
            //else if (DisplayMouseMessages)
            //    s = name + " " + e.ToString();

            //if (s.Length > 0)
            //{
            //    if (s != lastLine)
            //    {
            //        lastLine = s;
            //        _output.SelectedIndex = -1;
            //        _output.Items.Add(s + "\n");
            //        _output.TopIndex = Math.Max(0, _output.Items.Count - (_output.Height/_output.ItemHeight));
            //    }
            //}

            if (name.IndexOf("Mouse") == -1 && 
                name.IndexOf("Draw") == -1 && 
                name.IndexOf("Format") == -1 && 
                name.IndexOf("Cursor") == -1 && 
                name.IndexOf("StyleInfo") == -1 &&
                name.IndexOf("CellHitTest") ==-1)
            System.Console.WriteLine(name);
        }

		public override string ToString()
		{
			return GetInfo("");
		}

		private void grid_CurrentCellMoved(object sender, Syncfusion.Windows.Forms.Grid.GridCurrentCellMovedEventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("CurrentCellMoved", e);
		}

		private void grid_CurrentCellAcceptedChanges(object sender, System.ComponentModel.CancelEventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("CurrentCellAcceptedChanges", e);
		}

		private void grid_CurrentCellActivated(object sender, System.EventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("CurrentCellActivated", e);
		}

		private void grid_CurrentCellActivateFailed(object sender, Syncfusion.Windows.Forms.Grid.GridCurrentCellActivateFailedEventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("CurrentCellActivateFailed", e);
		}

		private void grid_CurrentCellActivating(object sender, GridCurrentCellActivatingEventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("CurrentCellActivating", e);
		}

		private void grid_CurrentCellChanged(object sender, EventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("CurrentCellChanged", e);

		}

		private void grid_CurrentCellChanging(object sender, CancelEventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("CurrentCellChanging", e);

		}

		private void grid_CurrentCellCloseDropDown(object sender, PopupClosedEventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("CurrentCellCloseDropDown", e);

		}

		private void grid_CurrentCellControlLostFocus(object sender, ControlEventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("CurrentCellControlLostFocus", e);

		}

		private void grid_CurrentCellMoveFailed(object sender, GridCurrentCellMoveFailedEventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("CurrentCellMoveFailed", e);

		}

		private void grid_CurrentCellRejectedChanges(object sender, EventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("CurrentCellRejectedChanges", e);

		}

		private void grid_CurrentCellShowedDropDown(object sender, EventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("CurrentCellShowedDropDown", e);

		}

		private void grid_CurrentCellShowingDropDown(object sender, GridCurrentCellShowingDropDownEventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("CurrentCellShowingDropDown", e);

		}

		private void grid_CurrentCellStartEditing(object sender, CancelEventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("CurrentCellStartEditing", e);

		}

		private void grid_CurrentCellValidated(object sender, EventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("CurrentCellValidated", e);

		}

		private void grid_CurrentCellValidating(object sender, CancelEventArgs e)
		{
			// Force the Renderer.ControValue to be in sync with the
			// displayed text. You have to decide on a case by case basis
			// (depeding on what cell renderer you have) if you want to do this ...
			//GridControlBase grid = (GridControlBase) sender;
			//grid.CurrentCell.Renderer.UpdateControlValue();

			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("CurrentCellValidating", e);
		}

		private void grid_CurrentCellControlDoubleClick(object sender, ControlEventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("CurrentCellControlDoubleClick", e);
		}

		private void grid_CurrentCellConfirmChangesFailed(object sender, EventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("CurrentCellConfirmChangesFailed", e);
		}

		private void grid_CurrentCellControlGotFocus(object sender, ControlEventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("CurrentCellControlGotFocus", e);

		}

		private void grid_CurrentCellDeactivateFailed(object sender, EventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("CurrentCellDeactivateFailed", e);

		}

		private void grid_CurrentCellDeactivating(object sender, CancelEventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("CurrentCellDeactivating", e);

		}

		private void grid_CurrentCellEditingComplete(object sender, EventArgs e)
		{

			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("CurrentCellEditingComplete", e);
		}

		private void grid_CurrentCellKeyDown(object sender, KeyEventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("CurrentCellKeyDown", e);

		}

		private void grid_CurrentCellKeyPress(object sender, KeyPressEventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("CurrentCellKeyPress", e);

		}

		private void grid_CurrentCellKeyUp(object sender, KeyEventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("CurrentCellKeyUp", e);

		}

		private void grid_CurrentCellDeleting(object sender, CancelEventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("CurrentCellDeleting", e);

		}

		private void grid_CurrentCellMoving(object sender, GridCurrentCellMovingEventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("CurrentCellMoving", e);

		}

		private void grid_CurrentCellDeactivated(object sender, GridCurrentCellDeactivatedEventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("CurrentCellDeactivated", e);

		}

		private void grid_CurrentCellInitializeControlText(object sender, GridCurrentCellInitializeControlTextEventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("CurrentCellInitializeControlText", e);

		}

		private void grid_CurrentCellValidateString(object sender, GridCurrentCellValidateStringEventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("CurrentCellValidateString", e);
			
		}

		private void grid_CellButtonClicked(object sender, GridCellButtonClickedEventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("CellButtonClicked", e);

		}

		private void grid_CellClick(object sender, GridCellClickEventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("CellClick", e);

		}

		private void grid_CellDoubleClick(object sender, GridCellClickEventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("CellDoubleClick", e);

		}

		private void grid_CellMouseDown(object sender, GridCellMouseEventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("CellMouseDown", e);

		}

		private void grid_CellMouseHoverEnter(object sender, GridCellMouseEventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("CellMouseHoverEnter", e);

		}

		private void grid_CellMouseHoverLeave(object sender, GridCellMouseEventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("CellMouseHoverLeave", e);

		}

		private void grid_CellMouseUp(object sender, GridCellMouseEventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("CellMouseUp", e);

		}

		private void grid_CheckBoxClick(object sender, GridCellClickEventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("CheckBoxClick", e);

		}

		private void grid_PushButtonClick(object sender, GridCellPushButtonClickEventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("PushButtonClick", e);

		}

		private void grid_Click(object sender, EventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("Click", e);
		}

		private void grid_Deactivated(object sender, EventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("Deactivated", e);
		}

		private void grid_DoubleClick(object sender, EventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("DoubleClick", e);
		}

		private void grid_DragDrop(object sender, DragEventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("DragDrop", e);
		}

		private void grid_DragEnter(object sender, DragEventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("DragEnter", e);
		}

		private void grid_DragLeave(object sender, EventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("DragLeave", e);
		}

		private void grid_DragOver(object sender, DragEventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("DragOver", e);
		}

		private void grid_Enter(object sender, EventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("Enter", e);
		}

		private void grid_GotFocus(object sender, EventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("GotFocus", e);
		}

		private void grid_KeyDown(object sender, KeyEventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("KeyDown", e);
		}

		private void grid_KeyPress(object sender, KeyPressEventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("KeyPress", e);
		}

		private void grid_KeyUp(object sender, KeyEventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("KeyUp", e);
		}

		private void grid_Layout(object sender, LayoutEventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("Layout", e);
		}

		private void grid_Leave(object sender, EventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("Leave", e);
		}

		private void grid_LostFocus(object sender, EventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("LostFocus", e);
		}
		
		private void grid_MouseDown(object sender, MouseEventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("MouseDown", e);
		}

		private void grid_MouseUp(object sender, MouseEventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("MouseUp", e);
		}

		private void grid_MouseEnter(object sender, EventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("MouseEnter", e);
		}

		private void grid_MouseLeave(object sender, EventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("MouseLeave", e);
		}

		private void grid_QueryCanOleDragRange(object sender, GridQueryCanOleDragRangeEventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("QueryCanOleDragRange", e);
		}

		private void grid_QueryNextCurrentCellPosition(object sender, GridQueryNextCurrentCellPositionEventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("QueryNextCurrentCellPosition", e);
		}

		private void grid_QueryOleDataSourceData(object sender, GridQueryOleDataSourceDataEventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("QueryOleDataSourceData", e);
		}

		private void grid_ResizingColumns(object sender, GridResizingColumnsEventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("ResizingColumns", e);
		}

		private void grid_ResizingRows(object sender, GridResizingRowsEventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("ResizingRows", e);
		}

		private void grid_ScrollInfoChanged(object sender, EventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("ScrollInfoChanged", e);
		}

		private void grid_SelectionDragging(object sender, GridSelectionDragEventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("SelectionDragging", e);
		}

		private void grid_SelectionDragged(object sender, GridSelectionDragEventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("SelectionDragged", e);
		}

		private void grid_StartAutoScrolling(object sender, StartAutoScrollingEventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("StartAutoScrolling", e);
		}

		private void grid_Validated(object sender, EventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("Validated", e);
		}

		private void grid_Validating(object sender, CancelEventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("Validating", e);
		}

		private void grid_WrapCellNextControlInForm(object sender, GridWrapCellNextControlInFormEventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
			AppendOutput("WrapCellNextControlInForm", e);
		}

/*******************START EVENTS************/

        private void gridRuleAlerts_TableControlCellButtonClicked(object sender, GridTableControlCellButtonClickedEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlCellButtonClicked", e);
        }

        private void gridRuleAlerts_TableControlCellCancelMode(object sender, GridTableControlCellMouseEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlCellCancelMode", e);
        }

        private void gridRuleAlerts_TableControlCellClick(object sender, GridTableControlCellClickEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlCellClick", e);

        }

        private void gridRuleAlerts_TableControlCellCursor(object sender, GridTableControlCellCursorEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlCellCursor", e);

        }

        private void gridRuleAlerts_TableControlCellDoubleClick(object sender, GridTableControlCellClickEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlCellDoubleClick", e);

        }

        private void gridRuleAlerts_TableControlCellDrawn(object sender, GridTableControlDrawCellEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlCellDrawn", e);

        }

        private void gridRuleAlerts_TableControlCellHitTest(object sender, GridTableControlCellHitTestEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlCellHitTest", e);

        }

        private void gridRuleAlerts_TableControlCellMouseDown(object sender, GridTableControlCellMouseEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlCellMouseDown", e);

        }

        private void gridRuleAlerts_TableControlCellMouseHover(object sender, GridTableControlCellMouseEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlCellMouseHover", e);

        }

        private void gridRuleAlerts_TableControlCellMouseHoverEnter(object sender, GridTableControlCellMouseEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlCellMouseHoverEnter", e);

        }

        private void gridRuleAlerts_TableControlCellMouseHoverLeave(object sender, GridTableControlCellMouseEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlCellMouseHoverLeave", e);

        }

        private void gridRuleAlerts_TableControlCellMouseMove(object sender, GridTableControlCellMouseEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlCellMouseMove", e);

        }

        private void gridRuleAlerts_TableControlCellMouseUp(object sender, GridTableControlCellMouseEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlCellMouseUp", e);

        }

        private void gridRuleAlerts_TableControlCheckBoxClick(object sender, GridTableControlCellClickEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlCheckBoxClick", e);

        }

        private void gridRuleAlerts_TableControlCurrentCellAcceptedChanges(object sender, GridTableControlCancelEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlCurrentCellAcceptedChanges", e);
            

        }

        private void gridRuleAlerts_TableControlCurrentCellActivated(object sender, GridTableControlEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlCurrentCellActivated", e);

        }

        private void gridRuleAlerts_TableControlCurrentCellActivateFailed(object sender, GridTableControlCurrentCellActivateFailedEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlCurrentCellActivateFailed", e);

        }

        private void gridRuleAlerts_TableControlCurrentCellActivating(object sender, GridTableControlCurrentCellActivatingEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlCurrentCellActivating", e);

        }

        private void gridRuleAlerts_TableControlCurrentCellChanging(object sender, GridTableControlCancelEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlCurrentCellChanging", e);

        }

        private void gridRuleAlerts_TableControlCurrentCellConfirmChangesFailed(object sender, GridTableControlEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlCurrentCellConfirmChangesFailed", e);

        }

        private void gridRuleAlerts_TableControlCurrentCellControlGotFocus(object sender, GridTableControlControlEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlCurrentCellControlGotFocus", e);

        }

        private void gridRuleAlerts_TableControlCurrentCellControlKeyMessage(object sender, GridTableControlCurrentCellControlKeyMessageEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlCurrentCellControlKeyMessage", e);

        }

        private void gridRuleAlerts_TableControlCurrentCellControlLostFocus(object sender, GridTableControlControlEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlCurrentCellControlLostFocus", e);

        }

        private void gridRuleAlerts_TableControlCurrentCellDeactivated(object sender, GridTableControlCurrentCellDeactivatedEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlCurrentCellDeactivated", e);

        }

        private void gridRuleAlerts_TableControlCurrentCellDeactivateFailed(object sender, GridTableControlEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlCurrentCellDeactivateFailed", e);

        }

        private void gridRuleAlerts_TableControlCurrentCellDeactivating(object sender, GridTableControlCancelEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlCurrentCellDeactivating", e);
        }

        private void gridRuleAlerts_TableControlCurrentCellDeleting(object sender, GridTableControlCancelEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlCurrentCellDeleting", e);

        }

        private void gridRuleAlerts_TableControlCurrentCellEditingComplete(object sender, GridTableControlEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlCurrentCellEditingComplete", e);

        }

        private void gridRuleAlerts_TableControlCurrentCellErrorMessage(object sender, GridTableControlCurrentCellErrorMessageEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlCurrentCellErrorMessage", e);
        }

        private void gridRuleAlerts_TableControlCurrentCellInitializeControlText(object sender, GridTableControlCurrentCellInitializeControlTextEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlCurrentCellInitializeControlText", e);
        }

        private void gridRuleAlerts_TableControlCurrentCellKeyDown(object sender, GridTableControlKeyEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlCurrentCellKeyDown", e);
        }

        private void gridRuleAlerts_TableControlCurrentCellKeyPress(object sender, GridTableControlKeyPressEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlCurrentCellKeyPress", e);
        }

        private void gridRuleAlerts_TableControlCurrentCellKeyUp(object sender, GridTableControlKeyEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlCurrentCellKeyUp", e);
        }

        private void gridRuleAlerts_TableControlCurrentCellMoved(object sender, GridTableControlCurrentCellMovedEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlCurrentCellMoved", e);
        }

        private void gridRuleAlerts_TableControlCurrentCellMoveFailed(object sender, GridTableControlCurrentCellMoveFailedEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlCurrentCellMoveFailed", e);
        }

        private void gridRuleAlerts_TableControlCurrentCellMoving(object sender, GridTableControlCurrentCellMovingEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlCurrentCellMoving", e);
        }

        private void gridRuleAlerts_TableControlCurrentCellRejectedChanges(object sender, GridTableControlEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlCurrentCellRejectedChanges", e);
        }

        private void gridRuleAlerts_TableControlCurrentCellShowedDropDown(object sender, GridTableControlEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlCurrentCellShowedDropDown", e);
        }

        private void gridRuleAlerts_TableControlCurrentCellShowingDropDown(object sender, GridTableControlCurrentCellShowingDropDownEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlCurrentCellShowingDropDown", e);
        }

        private void gridRuleAlerts_TableControlCurrentCellStartEditing(object sender, GridTableControlCancelEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlCurrentCellStartEditing", e);
        }

        private void gridRuleAlerts_TableControlCurrentCellValidated(object sender, GridTableControlEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlCurrentCellValidated", e);
        }

        private void gridRuleAlerts_TableControlCurrentCellValidateString(object sender, GridTableControlCurrentCellValidateStringEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlCurrentCellValidateString", e);

        }

        private void gridRuleAlerts_TableControlCurrentCellValidating(object sender, GridTableControlCancelEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlCurrentCellValidateString", e);

        }

        private void gridRuleAlerts_TableControlDrawCell(object sender, GridTableControlDrawCellEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlDrawCell", e);

        }

        private void gridRuleAlerts_TableControlDrawCellBackground(object sender, GridTableControlDrawCellBackgroundEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlDrawCell", e);

        }

        private void gridRuleAlerts_TableControlDrawCellButton(object sender, GridTableControlDrawCellButtonEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlDrawCellButton", e);

        }

        private void gridRuleAlerts_TableControlDrawCellDisplayText(object sender, GridTableControlDrawCellDisplayTextEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlDrawCellDisplayText", e);

        }

        private void gridRuleAlerts_TableControlDrawCellFrameAppearance(object sender, GridTableControlDrawCellBackgroundEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlDrawCellFrameAppearance", e);

        }

        private void gridRuleAlerts_TableControlDrawCurrentCellBorder(object sender, GridTableControlDrawCurrentCellBorderEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlDrawCurrentCellBorder", e);

        }

        private void gridRuleAlerts_TableControlHScrollPixelPosChanged(object sender, GridTableControlScrollPositionChangedEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlHScrollPixelPosChanged", e);

        }

        private void gridRuleAlerts_TableControlHScrollPixelPosChanging(object sender, GridTableControlScrollPositionChangingEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlHScrollPixelPosChanging", e);

        }

        private void gridRuleAlerts_TableControlKeyDown(object sender, GridTableControlKeyEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlKeyDown", e);

        }

        private void gridRuleAlerts_TableControlKeyPress(object sender, GridTableControlKeyPressEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlKeyPress", e);

        }

        private void gridRuleAlerts_TableControlKeyUp(object sender, GridTableControlKeyEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlKeyUp", e);

        }

        private void gridRuleAlerts_TableControlLeftColChanged(object sender, GridTableControlRowColIndexChangedEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlLeftColChanged", e);

        }

        private void gridRuleAlerts_TableControlLeftColChanging(object sender, GridTableControlRowColIndexChangingEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlLeftColChanging", e);

        }

        private void gridRuleAlerts_TableControlMouseDown(object sender, GridTableControlMouseEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlMouseDown", e);

        }

        private void gridRuleAlerts_TableControlMouseWheel(object sender, GridTableControlMouseEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlMouseWheel", e);

        }

        private void gridRuleAlerts_TableControlMoveCurrentCellDirection(object sender, GridTableControlMoveCurrentCellDirectionEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlMoveCurrentCellDirection", e);

        }

        private void gridRuleAlerts_TableControlPrepareViewStyleInfo(object sender, GridTableControlPrepareViewStyleInfoEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlPrepareViewStyleInfo", e);

        }


        private void gridRuleAlerts_TableControlDrawCellButtonBackground(object sender, GridTableControlCellPushButtonClickEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlDrawCellButtonBackground", e);
        }


        private void gridRuleAlerts_TableControlPushButtonClick(object sender, GridTableControlCellPushButtonClickEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlPushButtonClick", e);
        }

        private void gridRuleAlerts_TableControlQueryAllowArrowKeyNavigateTo(object sender, GridQueryAllowArrowKeyNavigateToEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlQueryAllowArrowKeyNavigateTo", e);
        }

        private void gridRuleAlerts_TableControlQueryAllowDragColumn(object sender, GridQueryAllowDragColumnEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlQueryAllowDragColumn", e);
        }

        private void gridRuleAlerts_TableControlQueryAllowGroupByColumn(object sender, GridQueryAllowGroupByColumnEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlQueryAllowGroupByColumn", e);
        }

        private void gridRuleAlerts_TableControlQueryAllowSortColumn(object sender, GridQueryAllowSortColumnEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlQueryAllowSortColumn", e);
        }

        private void gridRuleAlerts_TableControlQueryNextCurrentCellPosition(object sender, GridTableControlQueryNextCurrentCellPositionEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlQueryNextCurrentCellPosition", e);
        }

        private void gridRuleAlerts_TableControlQueryScrollCellInView(object sender, GridTableControlQueryScrollCellInViewEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlQueryScrollCellInView", e);
        }

        private void gridRuleAlerts_TableControlResizingColumns(object sender, GridTableControlResizingColumnsEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlResizingColumns", e);
        }

        private void gridRuleAlerts_TableControlResizingRows(object sender, GridTableControlResizingRowsEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlResizingColumns", e);
        }

        private void gridRuleAlerts_TableControlScrollTipFeedback(object sender, GridTableControlScrollTipFeedbackEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlScrollTipFeedback", e);
        }

        private void gridRuleAlerts_TableControlTopRowChanged(object sender, GridTableControlRowColIndexChangedEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlTopRowChanged", e);
        }

        private void gridRuleAlerts_TableControlTopRowChanging(object sender, GridTableControlRowColIndexChangingEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlTopRowChanging", e);
        }

        private void gridRuleAlerts_TableControlVScrollPixelPosChanged(object sender, GridTableControlScrollPositionChangedEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlVScrollPixelPosChanged", e);
        }

        private void gridRuleAlerts_TableControlVScrollPixelPosChanging(object sender, GridTableControlScrollPositionChangingEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlVScrollPixelPosChanging", e);
        }

        private void gridRuleAlerts_TableControlWrapCellNextControlInForm(object sender, GridTableControlWrapCellNextControlInFormEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableControlWrapCellNextControlInForm", e);
        }

        private void gridRuleAlerts_VisibleChanged(object sender, EventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("VisibleChanged", e);
        }

        private void gridRuleAlerts_Validating(object sender, CancelEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("Validating", e);
        }

        private void gridRuleAlerts_Validated(object sender, EventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("Validated", e);
        }

        private void gridRuleAlerts_TextChanged(object sender, EventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TextChanged", e);
        }

        private void gridRuleAlerts_TabStopChanged(object sender, EventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TabStopChanged", e);
        }

        private void gridRuleAlerts_TableSourceListChanged(object sender, TableEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TableSourceListChanged", e);
        }

        private void gridRuleAlerts_BindingContextChanged(object sender, EventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("BindingContextChanged", e);
        }

        private void gridRuleAlerts_CategorizedRecords(object sender, TableEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("CategorizedRecords", e);
        }

        private void gridRuleAlerts_CategorizingRecords(object sender, TableEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("CategorizingRecords", e);
        }

        private void gridRuleAlerts_CausesValidationChanged(object sender, EventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("CausesValidationChanged", e);
        }

        private void gridRuleAlerts_ChangeUICues(object sender, UICuesEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("ChangeUICues", e);
        }

        private void gridRuleAlerts_Click(object sender, EventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("Click", e);
        }

        private void gridRuleAlerts_ClientSizeChanged(object sender, EventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("ClientSizeChanged", e);
        }

        private void gridRuleAlerts_ContextMenuStripChanged(object sender, EventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("ContextMenuStripChanged", e);
        }

        private void gridRuleAlerts_ControlAdded(object sender, ControlEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("ControlAdded", e);
        }

        private void gridRuleAlerts_ControlRemoved(object sender, ControlEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("ControlRemoved", e);
        }

        private void gridRuleAlerts_CurrentRecordContextChange(object sender, CurrentRecordContextChangeEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("CurrentRecordContextChange", e);
        }

        private void gridRuleAlerts_CurrentRecordManagerReset(object sender, TableEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("CurrentRecordManagerReset", e);
        }

        private void gridRuleAlerts_CursorChanged(object sender, EventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("CursorChanged", e);
        }

        private void gridRuleAlerts_DisplayElementChanged(object sender, DisplayElementChangedEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("DisplayElementChanged", e);
        }

        private void gridRuleAlerts_DisplayElementChanging(object sender, DisplayElementChangingEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("DisplayElementChanging", e);
        }

        private void gridRuleAlerts_DockChanged(object sender, EventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("DockChanged", e);
        }

        private void gridRuleAlerts_DoubleClick(object sender, EventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("DoubleClick", e);
        }

        private void gridRuleAlerts_DragDrop(object sender, DragEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("DragDrop", e);
        }

        private void gridRuleAlerts_GroupAdded(object sender, GroupEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("GroupAdded", e);
        }

        private void gridRuleAlerts_GroupCollapsed(object sender, GroupEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("GroupCollapsed", e);
        }

        private void gridRuleAlerts_GroupCollapsing(object sender, GroupEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("GroupCollapsing", e);

        }

        private void gridRuleAlerts_GroupExpanded(object sender, GroupEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("GroupExpanded", e);

        }

        private void gridRuleAlerts_GroupExpanding(object sender, GroupEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("GroupExpanding", e);

        }

        private void gridRuleAlerts_GroupRemoving(object sender, GroupEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("GroupRemoving", e);

        }

        private void gridRuleAlerts_KeyDown(object sender, KeyEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("KeyDown", e);

        }

        private void gridRuleAlerts_KeyPress(object sender, KeyPressEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("KeyPress", e);

        }

        private void gridRuleAlerts_KeyUp(object sender, KeyEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("KeyUp", e);

        }

        private void gridRuleAlerts_Layout(object sender, LayoutEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("Layout", e);

        }

        private void gridRuleAlerts_Leave(object sender, EventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("Leave", e);

        }

        private void gridRuleAlerts_LocationChanged(object sender, EventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("LocationChanged", e);

        }

        private void gridRuleAlerts_MarginChanged(object sender, EventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("MarginChanged", e);

        }

        private void gridRuleAlerts_MouseCaptureChanged(object sender, EventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("MouseCaptureChanged", e);

        }

        private void gridRuleAlerts_MouseClick(object sender, MouseEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("MouseClick", e);

        }

        private void gridRuleAlerts_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("MouseDoubleClick", e);

        }

        private void gridRuleAlerts_QueryCellFormattedText(object sender, GridCellTextEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("QueryCellFormattedText", e);

        }

        private void gridRuleAlerts_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("QueryCellStyleInfo", e);

        }

        private void gridRuleAlerts_QueryCellText(object sender, GridCellTextEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("QueryCellText", e);

        }

        private void gridRuleAlerts_QueryContinueDrag(object sender, QueryContinueDragEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("QueryContinueDrag", e);

        }

        private void gridRuleAlerts_RecordCollapsed(object sender, RecordEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("RecordCollapsed", e);

        }

        private void gridRuleAlerts_RecordCollapsing(object sender, RecordEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("RecordCollapsing", e);

        }

        private void gridRuleAlerts_RecordDeleted(object sender, RecordEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("RecordDeleted", e);

        }

        private void gridRuleAlerts_RecordExpanded(object sender, RecordEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("RecordExpanded", e);
            GridGroupingControl ggc = (GridGroupingControl)sender;
        }

        private void gridRuleAlerts_RecordExpanding(object sender, RecordEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("RecordExpanding", e);
            GridGroupingControl ggc = (GridGroupingControl)sender;

        }

        private void gridRuleAlerts_RecordValueChanged(object sender, RecordValueChangedEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("RecordValueChanged", e);

        }

        private void gridRuleAlerts_RecordValueChanging(object sender, RecordValueChangingEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("RecordValueChanging", e);

        }

        private void gridRuleAlerts_SaveCellFormattedText(object sender, GridCellTextEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("SaveCellFormattedText", e);

        }

        private void gridRuleAlerts_SaveCellText(object sender, GridCellTextEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("SaveCellText", e);

        }

        private void gridRuleAlerts_SaveValue(object sender, FieldValueEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("SaveValue", e);

        }

        private void gridRuleAlerts_SelectedRecordsChanging(object sender, SelectedRecordsChangedEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("SelectedRecordsChanging", e);

        }

        private void gridRuleAlerts_SortedItemsInGroup(object sender, GroupEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("SortedItemsInGroup", e);

        }

        private void gridRuleAlerts_SourceListListChanged(object sender, TableListChangedEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("SourceListListChanged", e);

        }

        private void gridRuleAlerts_SourceListListChangedCompleted(object sender, TableListChangedEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("SourceListListChangedCompleted", e);

        }

        private void gridRuleAlerts_SourceListRecordChanged(object sender, RecordChangedEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("SourceListRecordChanged", e);

        }

        private void gridRuleAlerts_SourceListRecordChanging(object sender, RecordChangedEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("SourceListRecordChanging", e);

        }

        private void gridRuleAlerts_TabIndexChanged(object sender, EventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("TabIndexChanged", e);

        }

        private void gridRuleAlerts_QueryValue(object sender, FieldValueEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("QueryValue", e);

        }

        private void gridRuleAlerts_QueryRecordMeetsFilterCriteria(object sender, QueryRecordMeetsFilterCriteriaEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("QueryRecordMeetsFilterCriteria", e);

        }

        private void gridRuleAlerts_QueryCoveredRange(object sender, GridTableQueryCoveredRangeEventArgs e)
        {
            TraceUtil.TraceCurrentMethodInfoIf(traceDebug, this, e);
            AppendOutput("QueryCoveredRange", e);

        }

/***************END EVENT*********/




	}
}