

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Text;

using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid;

//using Advent.MxRules.Common.Data;
using Advent.MxRules.Win;
//using Advent.MxRules.Win.Common;



namespace Advent.MxRules.Win.ExternalClient
{
    /// <summary>
	/// This sample demonstrates how to manually specify master-details relations 
	/// between three separate tables that primary keys and foreign key columns
	/// in common. 
	/// </summary>
	public class frmRuleAlert : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridRuleAlerts;

        #region Public Properties
        private int myRuleCheckID;
                
        public int RuleCheckID
        {
            get { return myRuleCheckID; }
            set { myRuleCheckID = value; }
        }

        private int myExceptionCount;

        public int ExceptionCount
        {
            get { return myExceptionCount; }
            set { myExceptionCount = value; }
        }

        private string myFinalDisposition;

        public string FinalDispositions
        {
            get { return myFinalDisposition; }
            set { myFinalDisposition = value; }
        }
        private string myWebAppPath;

        public string WebAppPath
        {
            get { return myWebAppPath; }
            set { myWebAppPath = value; }
        }
        private string myWebAppName;

        public string WebAppName
        {
            get { return myWebAppName; }
            set { myWebAppName = value; }
        }
	
    #endregion
     
        #region Declare events Public Events
        public delegate void FireMoxyTicketExiredEventHandler(object sender, EventArgs args);
        public delegate void FireFDEventHandler(object sender, FinalDispositionEventArgs fd);
        public event FireFDEventHandler FinalDispositionEvent;
        public event FireMoxyTicketExiredEventHandler MoxyTicketExiredEvent;
        #endregion
      
        public string outPutString;

        //Private properties
        private Button cmdOK;
        private Button cmdCancel;
        private Button cmdSelectAll;
        private Button cmdSelectNone;
        private Button cmdPrint;
		private System.ComponentModel.Container components = null;
  

        private Button cmdOverride;
        private Button cmdForward;
        private Button cmdRestrict;
        private Panel pnlOption;
        private RadioButton rdbClassic;
        private RadioButton rdbPortfolio;
        private RadioButton rdbRule;
        private Label lblSettings;
        private Button cmdResetDefaults;
        private Button button1;

        private int myUseKey;

        private string myURL;

        public string URL
        {
            get { return myURL; }
            set { myURL = value; }
        }

	
        public frmRuleAlert()
        {
            InitializeComponent();
            SetGridAppearance();
       }

        public void Init(string webAppPath, string webAppName)
        {
            this.WebAppPath = webAppPath;
            this.WebAppName = webAppName;
            EventArgs eventArgs = new EventArgs();
            MoxyTicketExiredEvent(this, eventArgs);
            this.URL = webAppPath + "/" + webAppName + "/services";
        }

        public void ResetMoxyToken(byte[] moxyToken)
        {
            //ClientController.SetSessionID(Advent.MxRules.Common.Tools.HexConvert.ByteToString(moxyToken));
            //ClientController.SetWebAppPath(this.WebAppPath);
        }

        public int RunRuleCheckExecMoxy(int UseKey, int RequestingAppID, int WorkEventID)
        {
            int numberOfTries = 3;
            int iCounter = 0;
            while (true)
            {
                try
                {
                    DataTable dt = RuleCheckExecMoxy(UseKey, RequestingAppID, WorkEventID);
                    this.RuleCheckID = Convert.ToInt32(dt.Rows[0][dt.Columns["RuleCheckID"].Ordinal]);
                    this.ExceptionCount = Convert.ToInt32(dt.Rows[0][dt.Columns["ExceptionCount"].Ordinal]);
                    PopulateGrid(RuleCheckID);
                    return ExceptionCount > 0 ? this.RuleCheckID : 0;
                }
                catch (Exception ex)
                {
                    if (ex.Message.IndexOf("Session has expired") != -1 && iCounter < numberOfTries)
                    {
                        EventArgs eventArgs = new EventArgs();
                        MoxyTicketExiredEvent(this, eventArgs);
                        iCounter++;
                    }else
                        throw ex;
                }
            
            
            }
            
            
            
        }
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.gridRuleAlerts = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
            this.cmdOK = new System.Windows.Forms.Button();
            this.cmdCancel = new System.Windows.Forms.Button();
            this.cmdSelectAll = new System.Windows.Forms.Button();
            this.cmdSelectNone = new System.Windows.Forms.Button();
            this.cmdPrint = new System.Windows.Forms.Button();
            this.cmdOverride = new System.Windows.Forms.Button();
            this.cmdForward = new System.Windows.Forms.Button();
            this.cmdRestrict = new System.Windows.Forms.Button();
            this.pnlOption = new System.Windows.Forms.Panel();
            this.lblSettings = new System.Windows.Forms.Label();
            this.cmdResetDefaults = new System.Windows.Forms.Button();
            this.button1 = new System.Windows.Forms.Button();
            this.rdbClassic = new System.Windows.Forms.RadioButton();
            this.rdbPortfolio = new System.Windows.Forms.RadioButton();
            this.rdbRule = new System.Windows.Forms.RadioButton();
            ((System.ComponentModel.ISupportInitialize)(this.gridRuleAlerts)).BeginInit();
            this.pnlOption.SuspendLayout();
            this.SuspendLayout();
            // 
            // gridRuleAlerts
            // 
            this.gridRuleAlerts.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.gridRuleAlerts.BackColor = System.Drawing.SystemColors.Window;
            this.gridRuleAlerts.Location = new System.Drawing.Point(10, 10);
            this.gridRuleAlerts.Name = "gridRuleAlerts";
            this.gridRuleAlerts.Size = new System.Drawing.Size(773, 356);
            this.gridRuleAlerts.TabIndex = 0;
            this.gridRuleAlerts.Text = "gridRuleAlerts";
            CurrentCellEventTracer ccet = new CurrentCellEventTracer();
            //ccet.WireGridEvents(this.gridRuleAlerts);
            
            // 
            // cmdOK
            // 
            this.cmdOK.BackColor = System.Drawing.Color.LightSkyBlue;
            this.cmdOK.Location = new System.Drawing.Point(523, 379);
            this.cmdOK.Name = "cmdOK";
            this.cmdOK.Size = new System.Drawing.Size(75, 20);
            this.cmdOK.TabIndex = 1;
            this.cmdOK.Text = "OK";
            this.cmdOK.UseVisualStyleBackColor = false;
            this.cmdOK.Click += new System.EventHandler(this.btnOK_Click);
            // 
            // cmdCancel
            // 
            this.cmdCancel.BackColor = System.Drawing.Color.LightSkyBlue;
            this.cmdCancel.Location = new System.Drawing.Point(604, 379);
            this.cmdCancel.Name = "cmdCancel";
            this.cmdCancel.Size = new System.Drawing.Size(75, 20);
            this.cmdCancel.TabIndex = 2;
            this.cmdCancel.Text = "Cancel";
            this.cmdCancel.UseVisualStyleBackColor = false;
            this.cmdCancel.Click += new System.EventHandler(this.cmdCancel_Click);
            // 
            // cmdSelectAll
            // 
            this.cmdSelectAll.BackColor = System.Drawing.Color.LightSkyBlue;
            this.cmdSelectAll.Location = new System.Drawing.Point(13, 379);
            this.cmdSelectAll.Name = "cmdSelectAll";
            this.cmdSelectAll.Size = new System.Drawing.Size(75, 20);
            this.cmdSelectAll.TabIndex = 3;
            this.cmdSelectAll.Text = "Select All\r\n";
            this.cmdSelectAll.UseVisualStyleBackColor = false;
            // 
            // cmdSelectNone
            // 
            this.cmdSelectNone.BackColor = System.Drawing.Color.LightSkyBlue;
            this.cmdSelectNone.Location = new System.Drawing.Point(94, 379);
            this.cmdSelectNone.Name = "cmdSelectNone";
            this.cmdSelectNone.Size = new System.Drawing.Size(75, 20);
            this.cmdSelectNone.TabIndex = 4;
            this.cmdSelectNone.Text = "Select None";
            this.cmdSelectNone.UseVisualStyleBackColor = false;
            // 
            // cmdPrint
            // 
            this.cmdPrint.BackColor = System.Drawing.Color.LightSkyBlue;
            this.cmdPrint.Location = new System.Drawing.Point(685, 379);
            this.cmdPrint.Name = "cmdPrint";
            this.cmdPrint.Size = new System.Drawing.Size(75, 20);
            this.cmdPrint.TabIndex = 5;
            this.cmdPrint.Text = "Print";
            this.cmdPrint.UseVisualStyleBackColor = false;
            // 
            // cmdOverride
            // 
            this.cmdOverride.BackColor = System.Drawing.Color.LightSkyBlue;
            this.cmdOverride.Location = new System.Drawing.Point(175, 379);
            this.cmdOverride.Name = "cmdOverride";
            this.cmdOverride.Size = new System.Drawing.Size(75, 20);
            this.cmdOverride.TabIndex = 6;
            this.cmdOverride.Text = "Override";
            this.cmdOverride.UseVisualStyleBackColor = false;
            // 
            // cmdForward
            // 
            this.cmdForward.BackColor = System.Drawing.Color.LightSkyBlue;
            this.cmdForward.Location = new System.Drawing.Point(337, 379);
            this.cmdForward.Name = "cmdForward";
            this.cmdForward.Size = new System.Drawing.Size(75, 20);
            this.cmdForward.TabIndex = 8;
            this.cmdForward.Text = "Forward";
            this.cmdForward.UseVisualStyleBackColor = false;
            // 
            // cmdRestrict
            // 
            this.cmdRestrict.BackColor = System.Drawing.Color.LightSkyBlue;
            this.cmdRestrict.Location = new System.Drawing.Point(256, 379);
            this.cmdRestrict.Name = "cmdRestrict";
            this.cmdRestrict.Size = new System.Drawing.Size(75, 20);
            this.cmdRestrict.TabIndex = 7;
            this.cmdRestrict.Text = "Restrict";
            this.cmdRestrict.UseVisualStyleBackColor = false;
            // 
            // pnlOption
            // 
            this.pnlOption.Controls.Add(this.lblSettings);
            this.pnlOption.Controls.Add(this.cmdResetDefaults);
            this.pnlOption.Controls.Add(this.button1);
            this.pnlOption.Controls.Add(this.rdbClassic);
            this.pnlOption.Controls.Add(this.rdbPortfolio);
            this.pnlOption.Controls.Add(this.rdbRule);
            this.pnlOption.Location = new System.Drawing.Point(786, 56);
            this.pnlOption.Name = "pnlOption";
            this.pnlOption.Size = new System.Drawing.Size(117, 227);
            this.pnlOption.TabIndex = 9;
            // 
            // lblSettings
            // 
            this.lblSettings.AutoSize = true;
            this.lblSettings.Location = new System.Drawing.Point(8, 4);
            this.lblSettings.Name = "lblSettings";
            this.lblSettings.Size = new System.Drawing.Size(100, 13);
            this.lblSettings.TabIndex = 11;
            this.lblSettings.Text = "View Exceptions By\r\n";
            // 
            // cmdResetDefaults
            // 
            this.cmdResetDefaults.BackColor = System.Drawing.Color.LightSkyBlue;
            this.cmdResetDefaults.Location = new System.Drawing.Point(21, 147);
            this.cmdResetDefaults.Name = "cmdResetDefaults";
            this.cmdResetDefaults.Size = new System.Drawing.Size(75, 49);
            this.cmdResetDefaults.TabIndex = 10;
            this.cmdResetDefaults.Text = "Reset System\r\nDefaults\r\n";
            this.cmdResetDefaults.UseVisualStyleBackColor = false;
            this.cmdResetDefaults.Visible = false;
            // 
            // button1
            // 
            this.button1.BackColor = System.Drawing.Color.LightSkyBlue;
            this.button1.Location = new System.Drawing.Point(21, 104);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(75, 35);
            this.button1.TabIndex = 9;
            this.button1.Text = "Save as Default";
            this.button1.UseVisualStyleBackColor = false;
            this.button1.Visible = false;
            // 
            // rdbClassic
            // 
            this.rdbClassic.AutoSize = true;
            this.rdbClassic.Location = new System.Drawing.Point(9, 71);
            this.rdbClassic.Name = "rdbClassic";
            this.rdbClassic.Size = new System.Drawing.Size(86, 17);
            this.rdbClassic.TabIndex = 2;
            this.rdbClassic.TabStop = true;
            this.rdbClassic.Text = "Moxy Classic";
            this.rdbClassic.UseVisualStyleBackColor = true;
            this.rdbClassic.CheckedChanged += new System.EventHandler(this.rdbClassic_CheckedChanged);
            // 
            // rdbPortfolio
            // 
            this.rdbPortfolio.AutoSize = true;
            this.rdbPortfolio.Location = new System.Drawing.Point(8, 49);
            this.rdbPortfolio.Name = "rdbPortfolio";
            this.rdbPortfolio.Size = new System.Drawing.Size(63, 17);
            this.rdbPortfolio.TabIndex = 1;
            this.rdbPortfolio.TabStop = true;
            this.rdbPortfolio.Text = "Portfolio\r\n";
            this.rdbPortfolio.UseVisualStyleBackColor = true;
            this.rdbPortfolio.CheckedChanged += new System.EventHandler(this.rdbPortfolio_CheckedChanged);
            // 
            // rdbRule
            // 
            this.rdbRule.AutoSize = true;
            this.rdbRule.Checked = true;
            this.rdbRule.Location = new System.Drawing.Point(8, 27);
            this.rdbRule.Name = "rdbRule";
            this.rdbRule.Size = new System.Drawing.Size(109, 17);
            this.rdbRule.TabIndex = 0;
            this.rdbRule.TabStop = true;
            this.rdbRule.Text = "Severity and Rule";
            this.rdbRule.UseVisualStyleBackColor = true;
            this.rdbRule.CheckedChanged += new System.EventHandler(this.rdbRule_CheckedChanged);
            // 
            // frmRuleAlert
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.BackColor = System.Drawing.SystemColors.ActiveCaptionText;
            this.ClientSize = new System.Drawing.Size(913, 435);
            this.Controls.Add(this.pnlOption);
            this.Controls.Add(this.cmdForward);
            this.Controls.Add(this.cmdRestrict);
            this.Controls.Add(this.cmdOverride);
            this.Controls.Add(this.cmdPrint);
            this.Controls.Add(this.cmdSelectNone);
            this.Controls.Add(this.cmdSelectAll);
            this.Controls.Add(this.cmdCancel);
            this.Controls.Add(this.cmdOK);
            this.Controls.Add(this.gridRuleAlerts);
            this.Name = "frmRuleAlert";
            this.Text = "Rule Alerts";
            this.Load += new System.EventHandler(this.Form1_Load);
            ((System.ComponentModel.ISupportInitialize)(this.gridRuleAlerts)).EndInit();
            this.pnlOption.ResumeLayout(false);
            this.pnlOption.PerformLayout();
            this.ResumeLayout(false);

		}

  
		#endregion


		private void Form1_Load(object sender, System.EventArgs e)
		{
            this.gridRuleAlerts.TableControlCurrentCellShowingDropDown += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCurrentCellShowingDropDownEventHandler(this.gridRuleAlerts_TableControlCurrentCellShowingDropDown);
            //this.gridRuleAlerts.TableControlCurrentCellCloseDropDown += new GridTableControlPopupClosedEventHandler(gridRuleAlerts_TableControlCurrentCellCloseDropDown);
            //this.gridRuleAlerts.TableModel.ColWidthsChanged += new GridRowColSizeChangedEventHandler(TableModel_ColWidthsChanged);
            ////this.gridRuleAlerts.TableControlResizingColumns += new GridTableControlResizingColumnsEventHandler(gridRuleAlerts_TableControlResizingColumns);
            //this.gridRuleAlerts.TableControl.CellDoubleClick += new GridCellClickEventHandler(TableControl_CellDoubleClick);
            //this.gridRuleAlerts.TableControl.CurrentCellControlDoubleClick += new ControlEventHandler(TableControl_CurrentCellControlDoubleClick);

		}

        public void PopulateGrid(int _RuleCheckID)
        {
            int numberOfTries = 3;
            int iCounter = 0;
            while (true)
            {
                try
                {
                    if (this.rdbClassic.Checked)
                        PopulateGrid_ClassicView(_RuleCheckID);
                    else if (this.rdbPortfolio.Checked)
                        PopulateGrid_PortView(_RuleCheckID);
                    else if (this.rdbRule.Checked)
                        PopulateGrid_RuleView(_RuleCheckID);
                    
                    break;
                }
                catch (Exception ex)
                {
                    if ((ex.Message.IndexOf("Session has expired") != -1 || ex.Message.IndexOf("Unauthorized") != -1) && iCounter < numberOfTries)
                    {
                        EventArgs eventArgs = new EventArgs();
                        MoxyTicketExiredEvent(this, eventArgs);
                        iCounter++;
                    }
                    else
                        throw ex;
                }
            }   
        }

        private void PopulateGrid_ClassicView(int _RuleCheckID)
        {
            MyTimer mt = new MyTimer();

            this.SuspendLayout();

            MyTimer myTimer = new MyTimer();
            ResetGrid();
            SetGridAppearance();
            DataTable ruleTable = GetMoxyClassicViewTable(_RuleCheckID);
            // Register any DataTable/IList with SourceListSet, so that RelationDescriptor can resolve the name
            gridRuleAlerts.Engine.SourceListSet.Add("RuleTable", ruleTable);
            gridRuleAlerts.Engine.SourceListSet.Add("UserActions", UserActionCollection.CreateDefaultCollection());
            gridRuleAlerts.Engine.SourceListSet.Add("Reasons", ReasonCollection.CreateDefaultCollection());
            gridRuleAlerts.DataSource = ruleTable;

            this.gridRuleAlerts.ShowRelationFields = ShowRelationFields.ShowAllRelatedFields;

            this.gridRuleAlerts.TableDescriptor.AllowNew = false;

            this.gridRuleAlerts.TableDescriptor.Columns.AddRange(new GridColumnDescriptor[] {
                    new GridColumnDescriptor("RuleID"),
                    new GridColumnDescriptor("SeverityID"),
                    new GridColumnDescriptor("Severity","Severity","Severity", true, 100),
                    new GridColumnDescriptor("RuleName","RuleName","Rule", true, 100),
                    new GridColumnDescriptor("exceptionID"),    
                    new GridColumnDescriptor("ExceptionText", "ExceptionText", "Exception",true, 100),    
                    new GridColumnDescriptor("RuleDescription", "RuleDescription", "", true, 220),    
                    new GridColumnDescriptor("PortID"),
                    new GridColumnDescriptor("ObjectName","ObjectName", "PortCode", true, 100),
                    new GridColumnDescriptor("ObjectDescription","ObjectDescription","Portfolio", true, 100 ),
                    new GridColumnDescriptor("Actual", "Actual", "Actual", false, 50),
                    new GridColumnDescriptor("Off", "Off", "+/-", false, 50),
                    new GridColumnDescriptor("Action", "Action_Name", "Action", false, 80),
                    new GridColumnDescriptor("Reason", "Reason_Name", "Reason", false, 80),
                    new GridColumnDescriptor("Comments", "Comments", "Comments", false, 100)});


            //Hide Reference keys for all three tables
            gridRuleAlerts.TableDescriptor.VisibleColumns.Remove("SeverityID");
            gridRuleAlerts.TableDescriptor.VisibleColumns.Remove("RuleID");
            gridRuleAlerts.TableDescriptor.VisibleColumns.Remove("RuleName");
            gridRuleAlerts.TableDescriptor.VisibleColumns.Remove("PortID");
            gridRuleAlerts.TableDescriptor.VisibleColumns.Remove("exceptionID");
            gridRuleAlerts.TableDescriptor.VisibleColumns.Remove("RuleDescription");
            gridRuleAlerts.TableDescriptor.VisibleColumns.Remove("Decription");
            gridRuleAlerts.TableDescriptor.VisibleColumns.Remove("ObjectLongName");

            PopulateActionBox(gridRuleAlerts.TableDescriptor);
            PopulateReasonBox(gridRuleAlerts.TableDescriptor);
            
            gridRuleAlerts.Appearance.AnyHeaderCell.HorizontalAlignment = GridHorizontalAlignment.Left;
            gridRuleAlerts.Appearance.AnyHeaderCell.Font.Bold = true;
            gridRuleAlerts.Appearance.AnyCell.Borders.Left = new Syncfusion.Windows.Forms.Grid.GridBorder(Syncfusion.Windows.Forms.Grid.GridBorderStyle.None);
            gridRuleAlerts.Appearance.AnyCell.Borders.Right = new Syncfusion.Windows.Forms.Grid.GridBorder(Syncfusion.Windows.Forms.Grid.GridBorderStyle.None);
            gridRuleAlerts.Appearance.AnyCell.Borders.Top = new Syncfusion.Windows.Forms.Grid.GridBorder(Syncfusion.Windows.Forms.Grid.GridBorderStyle.None);
            gridRuleAlerts.Appearance.AnyCell.Borders.Bottom = new Syncfusion.Windows.Forms.Grid.GridBorder(Syncfusion.Windows.Forms.Grid.GridBorderStyle.None);

            gridRuleAlerts.TableDescriptor.Appearance.AnyHeaderCell.CellType = "Static";
            gridRuleAlerts.TableDescriptor.GetColumnDescriptor("Action").Appearance.AnyHeaderCell.CellType = "Static";
            gridRuleAlerts.TableDescriptor.GetColumnDescriptor("Reason").Appearance.AnyHeaderCell.CellType = "Static";

            gridRuleAlerts.TableDescriptor.TopLevelGroupOptions.ShowGroupHeader = false;


            //Top level caption
            gridRuleAlerts.TableDescriptor.TopLevelGroupOptions.CaptionText = "Rules Alert: {RecordCount} Items";

            //Hide row headers
            gridRuleAlerts.TableOptions.ShowRowHeader = false;

            this.gridRuleAlerts.ChildGroupOptions.ShowColumnHeaders = false;
            this.gridRuleAlerts.ChildGroupOptions.ShowCaption = false;
            this.gridRuleAlerts.ChildGroupOptions.ShowGroupHeader = false;

            this.gridRuleAlerts.TableOptions.ShowTreeLines = true;
            
            
        }
        private void PopulateGrid_RuleView(int _RuleCheckID)
        {
            MyTimer mt = new MyTimer();
            this.RuleCheckID = _RuleCheckID;
            this.SuspendLayout();
            MyTimer myTimer = new MyTimer();
            ResetGrid();
            SetGridAppearance();

            DataTable ruleTable = GetRuleTable(_RuleCheckID);
            DataTable portfolioTable = GetPortfolioTable(_RuleCheckID);
            DataTable exceptionTable = GetExceptionTable(_RuleCheckID);
            this.outPutString = "Load DataTables: " + myTimer.GetTime() + "\n\r";
            myTimer.ResetTimer();

            // Manually specify relations in grouping engine. The DataSet does not need to have any DataRelations.
            // This is the same approach that should be used if you want to set up relation ships
            // between independent IList.
            GridRelationDescriptor ruleToPortRelDescriptor = new GridRelationDescriptor();
            ruleToPortRelDescriptor.ChildTableName = "PortfolioTable";
            ruleToPortRelDescriptor.RelationKind = RelationKind.RelatedMasterDetails;
            ruleToPortRelDescriptor.RelationKeys.Add("ruleID", "RuleID");

            // Add relation to RuleTable 
            gridRuleAlerts.TableDescriptor.Relations.Add(ruleToPortRelDescriptor);

            GridRelationDescriptor portToExceptionRelDescriptor = new GridRelationDescriptor();
            portToExceptionRelDescriptor.ChildTableName = "ExceptionTable";
            portToExceptionRelDescriptor.RelationKind = RelationKind.RelatedMasterDetails;
            portToExceptionRelDescriptor.RelationKeys.Add("portID", "PortID");
            portToExceptionRelDescriptor.RelationKeys.Add("RuleID", "RuleID");

            // Add relation to ExceptionTable 
            ruleToPortRelDescriptor.ChildTableDescriptor.Relations.Add(portToExceptionRelDescriptor);

            PopulateActionBox(ruleToPortRelDescriptor);
            PopulateActionBox(portToExceptionRelDescriptor);
            PopulateActionBox(gridRuleAlerts.TableDescriptor);

            PopulateReasonBox(ruleToPortRelDescriptor);
            PopulateReasonBox(portToExceptionRelDescriptor);
            PopulateReasonBox(gridRuleAlerts.TableDescriptor);

            this.gridRuleAlerts.TableDescriptor.Columns.AddRange(new GridColumnDescriptor[] {
            new GridColumnDescriptor("ruleID"),
            new GridColumnDescriptor("SeverityName","SeverityName","Severity", true, 48),
            new GridColumnDescriptor("RuleName","RuleName","Rule", true, 100),
            new GridColumnDescriptor("RuleDescription", "RuleDecription", "Description", true, 220),
            new GridColumnDescriptor("Actual", "Actual", "Actual", false, 50),
            new GridColumnDescriptor("Off", "Off", "+/-", false, 50),
            new GridColumnDescriptor("Action", "Action_Name", "Action", false, 100),
            new GridColumnDescriptor("Reason", "Reason_Name", "Reason", false, 100),
            new GridColumnDescriptor("Comments", "Comments", "Comments", false, 100)});

            // Register any DataTable/IList with SourceListSet, so that RelationDescriptor can resolve the name
            gridRuleAlerts.Engine.SourceListSet.Add("RuleTable", ruleTable);
            gridRuleAlerts.Engine.SourceListSet.Add("PortfolioTable", portfolioTable);
            gridRuleAlerts.Engine.SourceListSet.Add("ExceptionTable", exceptionTable);
            gridRuleAlerts.Engine.SourceListSet.Add("UserActions", UserActionCollection.CreateDefaultCollection());
            gridRuleAlerts.Engine.SourceListSet.Add("Reasons", ReasonCollection.CreateDefaultCollection());

            gridRuleAlerts.DataSource = ruleTable;

            this.gridRuleAlerts.ShowRelationFields = ShowRelationFields.ShowAllRelatedFields;

            //Hide add new row on all three levels
            this.gridRuleAlerts.TableDescriptor.AllowNew = false;
            ruleToPortRelDescriptor.ChildTableDescriptor.AllowNew = false;
            portToExceptionRelDescriptor.ChildTableDescriptor.AllowNew = false;

            this.gridRuleAlerts.TableDescriptor.Relations["PortfolioTable"].ChildTableDescriptor.Columns.AddRange(new GridColumnDescriptor[] {
            new GridColumnDescriptor("portID"),
            new GridColumnDescriptor("ObjectName","ObjectName", "Portfolio", true, 129),
            new GridColumnDescriptor("ObjectDescription","ObjectDescription"," ", true, 220 ),
            new GridColumnDescriptor("RuleID","RuleID","RuleID",true, 0),
            new GridColumnDescriptor("Actual", "Actual", " ", true, 50),
            new GridColumnDescriptor("Off", "Off", " ", true, 50),
            new GridColumnDescriptor("Action", "Action_Name", " ", false, 100),
            new GridColumnDescriptor("Reason", "Reason_Name", " ", false, 100),
            new GridColumnDescriptor("Comments", "Comments", " ", false, 100)});

            portToExceptionRelDescriptor.ChildTableDescriptor.Columns.AddRange(new GridColumnDescriptor[] {
            new GridColumnDescriptor("exceptionID"),
            new GridColumnDescriptor("ExceptionText","ExceptionText", " ", true, 349),
            new GridColumnDescriptor("RuleID","RuleID","RuleID",true, 10),
            new GridColumnDescriptor("Actual", "Actual", " ", true, 50),
            new GridColumnDescriptor("Off", "Off", " ", true, 50),
            new GridColumnDescriptor("Action", "Action_Name", " ", false, 100),
            new GridColumnDescriptor("Reason", "Reason_Name", " ", false, 100),
            new GridColumnDescriptor("Comments", "Comments", " ", false, 100)});

            portToExceptionRelDescriptor.ChildTableDescriptor.Columns["Comments"].Appearance.AnyRecordFieldCell.Tag = "colComment";


            //Hide Reference keys for all three tables
            gridRuleAlerts.TableDescriptor.VisibleColumns.Remove("ruleID");
            ruleToPortRelDescriptor.ChildTableDescriptor.VisibleColumns.Remove("RuleID");
            ruleToPortRelDescriptor.ChildTableDescriptor.VisibleColumns.Remove("portID");
            portToExceptionRelDescriptor.ChildTableDescriptor.VisibleColumns.Remove("exceptionID");
            portToExceptionRelDescriptor.ChildTableDescriptor.VisibleColumns.Remove("RuleID");
            portToExceptionRelDescriptor.ChildTableDescriptor.VisibleColumns.Remove("PortID");

            ruleToPortRelDescriptor.ChildTableDescriptor.VisibleColumns.Remove("Action_Key");
            ruleToPortRelDescriptor.ChildTableDescriptor.VisibleColumns.Remove("Action_Name");
            ruleToPortRelDescriptor.ChildTableDescriptor.VisibleColumns.Remove("Action_Description");

            portToExceptionRelDescriptor.ChildTableDescriptor.VisibleColumns.Remove("Action_Key");
            portToExceptionRelDescriptor.ChildTableDescriptor.VisibleColumns.Remove("Action_Name");
            portToExceptionRelDescriptor.ChildTableDescriptor.VisibleColumns.Remove("Action_Description");

            ruleToPortRelDescriptor.ChildTableDescriptor.VisibleColumns.Remove("Reason_Key");
            ruleToPortRelDescriptor.ChildTableDescriptor.VisibleColumns.Remove("Reason_Name");
            ruleToPortRelDescriptor.ChildTableDescriptor.VisibleColumns.Remove("Reason_Description");

            portToExceptionRelDescriptor.ChildTableDescriptor.VisibleColumns.Remove("Reason_Key");
            portToExceptionRelDescriptor.ChildTableDescriptor.VisibleColumns.Remove("Reason_Name");
            portToExceptionRelDescriptor.ChildTableDescriptor.VisibleColumns.Remove("Reason_Description");
            portToExceptionRelDescriptor.ChildTableDescriptor.VisibleColumns.Remove("RuleDescription");

            portToExceptionRelDescriptor.ChildTableDescriptor.TableOptions.ColumnHeaderRowHeight = 0;
            gridRuleAlerts.Appearance.AnyHeaderCell.HorizontalAlignment = GridHorizontalAlignment.Left;
            gridRuleAlerts.Appearance.AnyHeaderCell.Font.Bold = true;
            gridRuleAlerts.Appearance.AnyCell.Borders.Left = new Syncfusion.Windows.Forms.Grid.GridBorder(Syncfusion.Windows.Forms.Grid.GridBorderStyle.None);
            gridRuleAlerts.Appearance.AnyCell.Borders.Right = new Syncfusion.Windows.Forms.Grid.GridBorder(Syncfusion.Windows.Forms.Grid.GridBorderStyle.None);
            gridRuleAlerts.Appearance.AnyCell.Borders.Top = new Syncfusion.Windows.Forms.Grid.GridBorder(Syncfusion.Windows.Forms.Grid.GridBorderStyle.None);
            gridRuleAlerts.Appearance.AnyCell.Borders.Bottom = new Syncfusion.Windows.Forms.Grid.GridBorder(Syncfusion.Windows.Forms.Grid.GridBorderStyle.None);

            gridRuleAlerts.TableDescriptor.Appearance.AnyHeaderCell.CellType = "Static";
            gridRuleAlerts.TableDescriptor.GetColumnDescriptor("Action").Appearance.AnyHeaderCell.CellType = "Static";
            //gridRuleAlerts.TableDescriptor.GetColumnDescriptor("Action").Appearance.AnyRecordFieldCell.CellType = "ComboBox";
            gridRuleAlerts.TableDescriptor.GetColumnDescriptor("Reason").Appearance.AnyHeaderCell.CellType = "Static";
            //gridRuleAlerts.TableDescriptor.GetColumnDescriptor("Reason").Appearance.AnyRecordFieldCell.CellType = "ComboBox";

            //gridRelationDescriptorException.ChildTableDescriptor.GetColumnDescriptor("Action").Appearance.AnyRecordFieldCell.CellType = "ComboBox";

            gridRuleAlerts.TableDescriptor.TopLevelGroupOptions.ShowGroupHeader = false;

            //Hide top level column header
            ruleToPortRelDescriptor.ChildTableDescriptor.TopLevelGroupOptions.ShowCaption = false;
            portToExceptionRelDescriptor.ChildTableDescriptor.TopLevelGroupOptions.ShowCaption = false;

            //Top level caption
            gridRuleAlerts.TableDescriptor.TopLevelGroupOptions.CaptionText = "Rules Alert: {RecordCount} Items";

            //Hide row headers
            gridRuleAlerts.TableOptions.ShowRowHeader = false;

            this.gridRuleAlerts.ChildGroupOptions.ShowColumnHeaders = false;
            this.gridRuleAlerts.ChildGroupOptions.ShowCaption = false;
            this.gridRuleAlerts.ChildGroupOptions.ShowGroupHeader = false;

            this.gridRuleAlerts.TableOptions.ShowTreeLines = true;

            ruleToPortRelDescriptor.ChildTableDescriptor.GetColumnDescriptor("ObjectName").Appearance.AnyHeaderCell.BorderMargins.Left = 48;
            ruleToPortRelDescriptor.ChildTableDescriptor.GetColumnDescriptor("ObjectName").Appearance.AnyCell.BorderMargins.Left = 30;

            this.gridRuleAlerts.TableDescriptor.GetColumnDescriptor("Action").Appearance.AnyHeaderCell.HorizontalAlignment = GridHorizontalAlignment.Center;
            this.gridRuleAlerts.TableDescriptor.GetColumnDescriptor("Reason").Appearance.AnyHeaderCell.HorizontalAlignment = GridHorizontalAlignment.Center;


            this.outPutString += "Set Grid Properties: " + myTimer.GetTime() + "\n\r";

            myTimer.ResetTimer();

            this.outPutString += "Populate list boxes: " + myTimer.GetTime() + "\n\r";
            this.ResumeLayout(false);
        }
        private void PopulateGrid_PortView(int _RuleCheckID)
        {
                MyTimer mt = new MyTimer();
                this.SuspendLayout();

                MyTimer myTimer = new MyTimer();
                ResetGrid();
                SetGridAppearance();

                DataTable portTable    = GetPortTable_PortView(_RuleCheckID);
                DataTable ruleTable    = GetRuleTable_PortView(_RuleCheckID);
                DataTable exceptTable   = GetExceptionTable(_RuleCheckID);
                this.outPutString = "Load DataTables: " + myTimer.GetTime() + "\n\r";
                myTimer.ResetTimer();

                // Manually specify relations in grouping engine. The DataSet does not need to have any DataRelations.
                // This is the same approach that should be used if you want to set up relation ships
                // between independent IList.
                GridRelationDescriptor ruleToPortRelDescriptor = new GridRelationDescriptor();
                ruleToPortRelDescriptor.ChildTableName = "RuleTable"; 
                ruleToPortRelDescriptor.RelationKind = RelationKind.RelatedMasterDetails;
                //ruleToPortRelDescriptor.RelationKeys.Add("ruleID", "RuleID");
                ruleToPortRelDescriptor.RelationKeys.Add("portID", "PortID");

                // Add relation to RuleTable 
                gridRuleAlerts.TableDescriptor.Relations.Add(ruleToPortRelDescriptor);

                GridRelationDescriptor ruleToExceptionRelDescriptor = new GridRelationDescriptor();
                ruleToExceptionRelDescriptor.ChildTableName = "ExceptionTable";  
                ruleToExceptionRelDescriptor.RelationKind = RelationKind.RelatedMasterDetails;
                ruleToExceptionRelDescriptor.RelationKeys.Add("ruleID", "RuleID");
                ruleToExceptionRelDescriptor.RelationKeys.Add("PortID", "PortID");

                // Add relation to ExceptionTable 
                ruleToPortRelDescriptor.ChildTableDescriptor.Relations.Add(ruleToExceptionRelDescriptor);

                PopulateActionBox(ruleToPortRelDescriptor);
                PopulateActionBox(ruleToExceptionRelDescriptor);
                PopulateActionBox(gridRuleAlerts.TableDescriptor);

                PopulateReasonBox(ruleToPortRelDescriptor);
                PopulateReasonBox(ruleToExceptionRelDescriptor);
                PopulateReasonBox(gridRuleAlerts.TableDescriptor);



                // Register any DataTable/IList with SourceListSet, so that RelationDescriptor can resolve the name
                gridRuleAlerts.Engine.SourceListSet.Add("PortTable", portTable);
                gridRuleAlerts.Engine.SourceListSet.Add("RuleTable", ruleTable);
                gridRuleAlerts.Engine.SourceListSet.Add("ExceptionTable", exceptTable);
                gridRuleAlerts.Engine.SourceListSet.Add("UserActions", UserActionCollection.CreateDefaultCollection());
                gridRuleAlerts.Engine.SourceListSet.Add("Reasons", ReasonCollection.CreateDefaultCollection());

                gridRuleAlerts.DataSource = portTable;

                this.gridRuleAlerts.ShowRelationFields = ShowRelationFields.ShowAllRelatedFields;

                //Hide add new row on all three levels
                this.gridRuleAlerts.TableDescriptor.AllowNew = false;
                ruleToPortRelDescriptor.ChildTableDescriptor.AllowNew = false;
                ruleToExceptionRelDescriptor.ChildTableDescriptor.AllowNew = false;

                this.gridRuleAlerts.TableDescriptor.Columns.AddRange(new GridColumnDescriptor[] {
                    new GridColumnDescriptor("portID"),
                    new GridColumnDescriptor("ruleID"),
                    new GridColumnDescriptor("ObjectName","ObjectName", "Portfolio", true, 129),
                    new GridColumnDescriptor("ObjectDescription","ObjectDescription","Description", true, 220 ),
                    new GridColumnDescriptor("Actual", "Actual", "Actual", true, 50),
                    new GridColumnDescriptor("Off", "Off", "Off+/-", true, 50),
                    new GridColumnDescriptor("Action", "Action_Name", "Action", false, 100),
                    new GridColumnDescriptor("Reason", "Reason_Name", "Reason", false, 100),
                    new GridColumnDescriptor("Comments", "Comments", "Comments", false, 100)});

                ruleToPortRelDescriptor.ChildTableDescriptor.Columns.AddRange(new GridColumnDescriptor[] {
                    new GridColumnDescriptor("ruleID"),
                    new GridColumnDescriptor("PortID"),
                    new GridColumnDescriptor("Severity","Severity"," ", true, 110),
                    new GridColumnDescriptor("RuleName","RuleName"," ", true, 100),
                    new GridColumnDescriptor("RuleDescription", "RuleDescription", "Rule ", true, 220),
                    new GridColumnDescriptor("Actual", "Actual", " ", false, 50),
                    new GridColumnDescriptor("Off", "Off", " ", false, 50),
                    new GridColumnDescriptor("Action", "Action_Name", " ", false, 100),
                    new GridColumnDescriptor("Reason", "Reason_Name", " ", false, 100),
                    new GridColumnDescriptor("Comments", "Comments", " ", false, 100)});


                ruleToExceptionRelDescriptor.ChildTableDescriptor.Columns.AddRange(new GridColumnDescriptor[] {
                    new GridColumnDescriptor("exceptionID"),
                    new GridColumnDescriptor("RuleID"),
                    new GridColumnDescriptor("PortID"),
                    new GridColumnDescriptor("ExceptionText","ExceptionText", " ", true, 330),
                    new GridColumnDescriptor("Actual", "Actual", " ", true, 50),
                    new GridColumnDescriptor("Off", "Off", " ", true, 50),
                    new GridColumnDescriptor("Action", "Action_Name", " ", false, 100),
                    new GridColumnDescriptor("Reason", "Reason_Name", " ", false, 100),
                    new GridColumnDescriptor("Comments", "Comments", " ", false, 100)});

                


                //Hide Reference keys for all three tables
                gridRuleAlerts.TableDescriptor.VisibleColumns.Remove("portID");
                gridRuleAlerts.TableDescriptor.VisibleColumns.Remove("ruleID");
                ruleToPortRelDescriptor.ChildTableDescriptor.VisibleColumns.Remove("ruleID");
                ruleToPortRelDescriptor.ChildTableDescriptor.VisibleColumns.Remove("PortID");
                ruleToPortRelDescriptor.ChildTableDescriptor.VisibleColumns.Remove("RuleName");
                
                ruleToExceptionRelDescriptor.ChildTableDescriptor.VisibleColumns.Remove("exceptionID");
                ruleToExceptionRelDescriptor.ChildTableDescriptor.VisibleColumns.Remove("PortID");
                ruleToExceptionRelDescriptor.ChildTableDescriptor.VisibleColumns.Remove("RuleID");

                //ruleToExceptionRelDescriptor.ChildTableDescriptor.VisibleColumns.Remove("exceptionID");
                //ruleToExceptionRelDescriptor.ChildTableDescriptor.VisibleColumns.Remove("RuleID");
                //ruleToExceptionRelDescriptor.ChildTableDescriptor.VisibleColumns.Remove("PortID");

                this.gridRuleAlerts.TableDescriptor.VisibleColumns.Remove("Action_Key");
                this.gridRuleAlerts.TableDescriptor.VisibleColumns.Remove("Action_Name");
                this.gridRuleAlerts.TableDescriptor.VisibleColumns.Remove("Action_Description");

                this.gridRuleAlerts.TableDescriptor.VisibleColumns.Remove("Reason_Key");
                this.gridRuleAlerts.TableDescriptor.VisibleColumns.Remove("Reason_Name");
                this.gridRuleAlerts.TableDescriptor.VisibleColumns.Remove("Reason_Description");

                ruleToExceptionRelDescriptor.ChildTableDescriptor.VisibleColumns.Remove("Action_Key");
                ruleToExceptionRelDescriptor.ChildTableDescriptor.VisibleColumns.Remove("Action_Name");
                ruleToExceptionRelDescriptor.ChildTableDescriptor.VisibleColumns.Remove("Action_Description");

                ruleToPortRelDescriptor.ChildTableDescriptor.VisibleColumns.Remove("Action_Key");
                ruleToPortRelDescriptor.ChildTableDescriptor.VisibleColumns.Remove("Action_Name");
                ruleToPortRelDescriptor.ChildTableDescriptor.VisibleColumns.Remove("Action_Description");

                ruleToExceptionRelDescriptor.ChildTableDescriptor.VisibleColumns.Remove("Reason_Key");
                ruleToExceptionRelDescriptor.ChildTableDescriptor.VisibleColumns.Remove("Reason_Name");
                ruleToExceptionRelDescriptor.ChildTableDescriptor.VisibleColumns.Remove("Reason_Description");

                ruleToPortRelDescriptor.ChildTableDescriptor.VisibleColumns.Remove("Reason_Key");
                ruleToPortRelDescriptor.ChildTableDescriptor.VisibleColumns.Remove("Reason_Name");
                ruleToPortRelDescriptor.ChildTableDescriptor.VisibleColumns.Remove("Reason_Description");
                //ruleToExceptionRelDescriptor.ChildTableDescriptor.VisibleColumns.Remove("Description");


                ruleToExceptionRelDescriptor.ChildTableDescriptor.TableOptions.ColumnHeaderRowHeight = 0;
                gridRuleAlerts.Appearance.AnyHeaderCell.HorizontalAlignment = GridHorizontalAlignment.Left;
                gridRuleAlerts.Appearance.AnyHeaderCell.Font.Bold = true;
                gridRuleAlerts.Appearance.AnyCell.Borders.Left = new Syncfusion.Windows.Forms.Grid.GridBorder(Syncfusion.Windows.Forms.Grid.GridBorderStyle.None);
                gridRuleAlerts.Appearance.AnyCell.Borders.Right = new Syncfusion.Windows.Forms.Grid.GridBorder(Syncfusion.Windows.Forms.Grid.GridBorderStyle.None);
                gridRuleAlerts.Appearance.AnyCell.Borders.Top = new Syncfusion.Windows.Forms.Grid.GridBorder(Syncfusion.Windows.Forms.Grid.GridBorderStyle.None);
                gridRuleAlerts.Appearance.AnyCell.Borders.Bottom = new Syncfusion.Windows.Forms.Grid.GridBorder(Syncfusion.Windows.Forms.Grid.GridBorderStyle.None);

                gridRuleAlerts.TableDescriptor.Appearance.AnyHeaderCell.CellType = "Static";
                gridRuleAlerts.TableDescriptor.GetColumnDescriptor("Action").Appearance.AnyHeaderCell.CellType = "Static";
                //gridRuleAlerts.TableDescriptor.GetColumnDescriptor("Action").Appearance.AnyRecordFieldCell.CellType = "ComboBox";
                gridRuleAlerts.TableDescriptor.GetColumnDescriptor("Reason").Appearance.AnyHeaderCell.CellType = "Static";
                //gridRuleAlerts.TableDescriptor.GetColumnDescriptor("Reason").Appearance.AnyRecordFieldCell.CellType = "ComboBox";

                //gridRelationDescriptorException.ChildTableDescriptor.GetColumnDescriptor("Action").Appearance.AnyRecordFieldCell.CellType = "ComboBox";

                gridRuleAlerts.TableDescriptor.TopLevelGroupOptions.ShowGroupHeader = false;

                //Hide top level column header
                ruleToPortRelDescriptor.ChildTableDescriptor.TopLevelGroupOptions.ShowCaption = false;
                ruleToExceptionRelDescriptor.ChildTableDescriptor.TopLevelGroupOptions.ShowCaption = false;

                //Top level caption
                gridRuleAlerts.TableDescriptor.TopLevelGroupOptions.CaptionText = "Rules Alert: {RecordCount} Items";

                //Hide row headers
                gridRuleAlerts.TableOptions.ShowRowHeader = false;

                this.gridRuleAlerts.ChildGroupOptions.ShowColumnHeaders = false;
                this.gridRuleAlerts.ChildGroupOptions.ShowCaption = false;
                this.gridRuleAlerts.ChildGroupOptions.ShowGroupHeader = false;

                this.gridRuleAlerts.TableOptions.ShowTreeLines = true;

                //ruleToPortRelDescriptor.ChildTableDescriptor.GetColumnDescriptor("PortCode").Appearance.AnyHeaderCell.BorderMargins.Left = 48;
                //ruleToPortRelDescriptor.ChildTableDescriptor.GetColumnDescriptor("PortCode").Appearance.AnyCell.BorderMargins.Left = 30;


                this.outPutString += "Set Grid Properties: " + myTimer.GetTime() + "\n\r";

                myTimer.ResetTimer();

                this.outPutString += "Populate list boxes: " + myTimer.GetTime() + "\n\r";
                this.ResumeLayout(false);
        }

        private void PopulateActionBox(GridRelationDescriptor descriptor) { PopulateActionBox(descriptor,1); }
        private void PopulateActionBox(TableDescriptor descriptor) { PopulateActionBox(descriptor,2); }
        private void PopulateActionBox(object descriptor, int type)
        {
            GridRelationDescriptor UserActionsRd = new GridRelationDescriptor();
            UserActionsRd.Name = "Action";
            UserActionsRd.RelationKind = RelationKind.ForeignKeyReference;
            UserActionsRd.ChildTableName = "UserActions";  // SourceListSet name for lookup
            UserActionsRd.RelationKeys.Add("Action", "Key");

            // Let's also customize the appearance of the dropdown table here:
            UserActionsRd.ChildTableDescriptor.Appearance.AlternateRecordFieldCell.BackColor = Color.Beige;
            
            //ReasonRd.ChildTableDescriptor.Columns.Add(new GridColumnDescriptor("Action")); // Description is a a custom property descriptor in UserActionCollection
            //ReasonRd.ChildTableDescriptor.Columns.Add(new GridColumnDescriptor("Action", "Description")); // Description is a a custom property descriptor in UserActionCollection
            UserActionsRd.ChildTableDescriptor.SortedColumns.Add("Action");
            UserActionsRd.ChildTableDescriptor.VisibleColumns.Add("Name");

            UserActionsRd.ChildTableDescriptor.AllowEdit = false;
            UserActionsRd.ChildTableDescriptor.AllowNew = false;  // Make pencil icon disappear, users can't modify states.
            UserActionsRd.ChildTableDescriptor.TableOptions.ColumnHeaderRowHeight = 0;

            if (type == 2)
            {
                TableDescriptor gt = (TableDescriptor)descriptor;
                gt.Relations.Add(UserActionsRd);
            }
            else
            {
                RelationDescriptor gt = (RelationDescriptor)descriptor;
                gt.ChildTableDescriptor.Relations.Add(UserActionsRd);

            }
        }

        private void PopulateReasonBox(GridRelationDescriptor descriptor) { PopulateReasonBox(descriptor, 1); }
        private void PopulateReasonBox(TableDescriptor descriptor) { PopulateReasonBox(descriptor, 2); }
        private void PopulateReasonBox(object descriptor, int type)
        {
            GridRelationDescriptor ReasonRd = new GridRelationDescriptor();
            ReasonRd.Name = "Reason";
            ReasonRd.RelationKind = RelationKind.ForeignKeyReference;
            ReasonRd.ChildTableName = "Reasons";  // SourceListSet name for lookup
            ReasonRd.RelationKeys.Add("Reason", "Key");

            // Let's also customize the appearance of the dropdown table here:
            ReasonRd.ChildTableDescriptor.Appearance.AlternateRecordFieldCell.BackColor = Color.Beige;

            //ReasonRd.ChildTableDescriptor.Columns.Add(new GridColumnDescriptor("Action")); // Description is a a custom property descriptor in UserActionCollection
            //ReasonRd.ChildTableDescriptor.Columns.Add(new GridColumnDescriptor("Action", "Description")); // Description is a a custom property descriptor in UserActionCollection
            ReasonRd.ChildTableDescriptor.SortedColumns.Add("Reason");
            ReasonRd.ChildTableDescriptor.VisibleColumns.Add("Name");
            ReasonRd.ChildTableDescriptor.AllowEdit = false;
            ReasonRd.ChildTableDescriptor.AllowNew = false;  // Make pencil icon disappear, users can't modify states.
            ReasonRd.ChildTableDescriptor.TableOptions.ColumnHeaderRowHeight = 0;

            if (type == 2)
            {
                TableDescriptor gt = (TableDescriptor)descriptor;
                gt.Relations.Add(ReasonRd);
            }
            else
            {
                RelationDescriptor gt = (RelationDescriptor)descriptor;
                gt.ChildTableDescriptor.Relations.Add(ReasonRd);

            }
        }

        
        
        private void ResetGrid()
        {
            //if (gridRuleAlerts != null)
            //    gridRuleAlerts.Dispose();

            this.gridRuleAlerts.ResetTableDescriptor();
            this.gridRuleAlerts.ResetChildGroupOptions();
            this.gridRuleAlerts.ResetTableOptions();
            this.gridRuleAlerts.ResetNestedTableGroupOptions();

            //this.gridRuleAlerts.ResetAppearance();
            //this.gridRuleAlerts.ResetBaseStyles();
            this.gridRuleAlerts.DataSource = null;
        }

        private void SetGridAppearance2()
        {
            MyTimer mt = new MyTimer();
            this.gridRuleAlerts.Appearance.RecordPlusMinusCell.BorderMargins.Left = 2;
            this.gridRuleAlerts.Appearance.RecordPlusMinusCell.BorderMargins.Right = 2;
            this.gridRuleAlerts.Appearance.RecordPlusMinusCell.BorderMargins.Top = 2;
            this.gridRuleAlerts.Appearance.RecordPlusMinusCell.BorderMargins.Bottom = 2;
            System.Console.WriteLine("*************** SetGridAppearance2 =" + mt.GetTime());

        }
        private void SetGridAppearance()
        {
            MyTimer mt = new MyTimer();
            //Form appearance
            this.BackColor = System.Drawing.SystemColors.ControlLightLight;
            this.components = new System.ComponentModel.Container();
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(908, 462);

            this.gridRuleAlerts.Appearance.RecordPlusMinusCell.BorderMargins.Left = 2;
            this.gridRuleAlerts.Appearance.RecordPlusMinusCell.BorderMargins.Right = 2;
            this.gridRuleAlerts.Appearance.RecordPlusMinusCell.BorderMargins.Top = 2;
            this.gridRuleAlerts.Appearance.RecordPlusMinusCell.BorderMargins.Bottom = 2;

            this.gridRuleAlerts.Appearance.ColumnHeaderCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.ActiveCaptionText);
            this.gridRuleAlerts.Appearance.GroupCaptionCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.ControlLightLight);
            this.gridRuleAlerts.Appearance.RowHeaderCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.ControlLightLight);
            this.gridRuleAlerts.Appearance.TopLeftHeaderCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.ControlLightLight);

            this.gridRuleAlerts.BackColor = System.Drawing.Color.AliceBlue;
            this.gridRuleAlerts.BorderStyle = System.Windows.Forms.BorderStyle.None;
            this.gridRuleAlerts.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));

            this.gridRuleAlerts.TableOptions.CaptionRowHeight = 18;
            this.gridRuleAlerts.TableOptions.ColumnHeaderRowHeight = 15;
            this.gridRuleAlerts.TableOptions.RecordRowHeight = 15;
            this.gridRuleAlerts.TabIndex = 0;
            this.gridRuleAlerts.TableOptions.ShowTableIndent = true;
            this.gridRuleAlerts.TableOptions.ShowTableIndentAsCoveredRange = true;

            this.gridRuleAlerts.Appearance.GroupHeaderSectionCell.Borders.Bottom = new Syncfusion.Windows.Forms.Grid.GridBorder(Syncfusion.Windows.Forms.Grid.GridBorderStyle.None);
            this.gridRuleAlerts.Appearance.ColumnHeaderCell.Borders.Bottom = new Syncfusion.Windows.Forms.Grid.GridBorder(Syncfusion.Windows.Forms.Grid.GridBorderStyle.None);
            this.gridRuleAlerts.Appearance.GroupCaptionCell.TextColor = System.Drawing.Color.MediumBlue;
            this.gridRuleAlerts.Appearance.GroupHeaderSectionCell.Borders.Bottom = new Syncfusion.Windows.Forms.Grid.GridBorder(Syncfusion.Windows.Forms.Grid.GridBorderStyle.None);
            this.gridRuleAlerts.Appearance.ColumnHeaderCell.Borders.Bottom = new Syncfusion.Windows.Forms.Grid.GridBorder(Syncfusion.Windows.Forms.Grid.GridBorderStyle.None);
            System.Console.WriteLine("***********  SetGridAppearance =" + mt.GetTime());
        }
			
		#region Populate Data Table
        private DataTable GetRuleTable(int iRuleCheckID)
        {
            return RuleCheckGetExceptions(iRuleCheckID, "RuleTable", 0);
        }

        private DataTable GetPortfolioTable(int iRuleCheckID)
        {
            return RuleCheckGetExceptions(iRuleCheckID, "PortfolioTable", 1);
		}

 		private DataTable GetExceptionTable(int iRuleCheckID)
        {
            return RuleCheckGetExceptions(iRuleCheckID, "ExceptionTable", 2);
		}

        private DataTable GetPortTable_PortView(int iRuleCheckID)
        {
            return RuleCheckGetExceptions(iRuleCheckID, "PortTable", 4);
        }

        private DataTable GetRuleTable_PortView(int iRuleCheckID)
        {
            return RuleCheckGetExceptions(iRuleCheckID, "RuleTable", 5);
        }

        private DataTable GetMoxyClassicViewTable(int iRuleCheckID)
        {
            return RuleCheckGetExceptions(iRuleCheckID, "ExceptionTable", 3);
        }

        
        
        private DataTable RuleCheckExecMoxy(int UseKey, int RequestionAppID, int WorkEventID)
        {
            //MxrDataSet dsData = null;
            //RuleCheckUIH oUIH = null;
            //oUIH = new RuleCheckUIH();
            //dsData = oUIH.RuleCheckExecMoxy(this.URL, "", UseKey, RequestionAppID, WorkEventID);
            
            return null;
        }

        private DataTable RuleCheckGetExceptions(int iRuleCheckID, string sTableName, int iMode)
        {
            //MxrDataSet dsData = null;
            //RuleCheckUIH oUIH = null;
            //oUIH = new RuleCheckUIH();
            //dsData = oUIH.RuleCheckGetExceptions(this.URL, "", iRuleCheckID, iMode);
            //dsData.MxRulesDataSet.Tables[0].TableName = sTableName;
            //DataSet ds = dsData.MyDataSet;
            //ds.WriteXml("c:\\temp\\" + sTableName + iMode.ToString() + ".xml");
            DataSet ds = new DataSet();
            //ds.ReadXml("c:\\temp\\" + sTableName + iMode.ToString() + ".xml");
            ds.ReadXml(sTableName + iMode.ToString() + ".xml");
            return ds.Tables[0];
            //return dsData.MxRulesDataSet.Tables[0];
        }

        private DataTable RuleCheckUpdateExceptions(int iRuleCheckID, string sExceptionAction)
        {
            //MxrDataSet dsData = null;
            //RuleCheckUIH oUIH = null;
            //oUIH = new RuleCheckUIH();
            //dsData = oUIH.RuleCheckUpdateExceptions(this.URL , "", iRuleCheckID, sExceptionAction);
            //dsData.MxRulesDataSet.Tables[0].TableName = sTableName;
            return null;
        }

        private DataSet RuleCheckGetFinalDisposition(int iRuleCheckID)
        {
            //MxrDataSet dsData = null;
            //RuleCheckUIH oUIH = null;
            //oUIH = new RuleCheckUIH();
            //dsData = oUIH.RuleCheckGetFinalDisposition(this.URL, "", iRuleCheckID);
            return null;
        }



#endregion

        #region Event Handlers
        private void gridRuleAlerts_TableControlDrawCellButtonBackground(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlDrawCellButtonBackgroundEventArgs e)
        {
            //if (e.Inner.Button.Text != "+" && e.Inner.Button.Text != "-")
            //    return;
            bool drawPressed = (e.Inner.ButtonState & ButtonState.Pushed) != 0;
            Rectangle rect = e.Inner.Bounds;
            Graphics g = e.Inner.Graphics;
            Color hilight = SystemColors.ControlLightLight;
            Color shadow = SystemColors.ControlDarkDark;

            if (!drawPressed)
            {
                Draw3dFrame(e.Inner.Graphics, rect.Left, rect.Top, rect.Right - 1, rect.Bottom - 1, 1,
                    hilight, shadow);
                g.FillRectangle(Brushes.LightSkyBlue, rect.Left + 1, rect.Top + 1, rect.Width - 2, rect.Height - 2);
            }
            else
            {
                Brush br = new SolidBrush(shadow);
                g.FillRectangle(br, Rectangle.FromLTRB(rect.Left, rect.Bottom - 1, rect.Right - 1, rect.Bottom));
                g.FillRectangle(br, Rectangle.FromLTRB(rect.Right - 1, rect.Top, rect.Right, rect.Bottom));
                g.FillRectangle(Brushes.LightSkyBlue, rect.Left + 1, rect.Top + 1, rect.Width - 2, rect.Height - 2);
                br.Dispose();
            }
            e.Inner.Cancel = true;
        }

        private static void Draw3dFrame(Graphics g, int x0, int y0, int x1, int y1, int w, Color rgbTopLeft, Color rgbBottomRight)
        {
            Rectangle rc;

            for (int i = 0; i != w; i++)
            {
                // Top 
                Brush brTL = new SolidBrush(rgbTopLeft);
                rc = Rectangle.FromLTRB(x0, y0, x1, y0 + 1);
                g.FillRectangle(brTL, rc);

                // Left 
                rc = Rectangle.FromLTRB(x0, y0, x0 + 1, y1);
                g.FillRectangle(brTL, rc);
                brTL.Dispose();

                Brush brBR = new SolidBrush(rgbBottomRight);

                // Bottom 
                rc = Rectangle.FromLTRB(x0, y1, x1 + 1, y1 + 1);
                g.FillRectangle(brBR, rc);

                // Right 
                rc = Rectangle.FromLTRB(x1, y0, x1 + 1, y1);
                g.FillRectangle(brBR, rc);
                brBR.Dispose();

                if (i != w - 1)
                {
                    x0++;
                    y0++;
                    x1--;
                    y1--;
                }
            }
        }


        #endregion

        #region ComboBox
        private void PopoulateComboBox(GridColumnDescriptor col)
        {
            col.Appearance.AnyRecordFieldCell.Text = "Cell1,2";
            col.Appearance.AnyRecordFieldCell.CellType = "ComboBox";
            col.Appearance.AnyRecordFieldCell.DataSource = GetTable();
            col.Appearance.AnyRecordFieldCell.DisplayMember = "Column2";
            col.Appearance.AnyRecordFieldCell.ValueMember = "Column2";
            col.Appearance.AnyRecordFieldCell.ReadOnly = false;
            col.Appearance.AnyRecordFieldCell.DropDownStyle = GridDropDownStyle.Editable;
            col.Appearance.AnyRecordFieldCell.Enabled = true;
            
            //col.Appearance.AnyRecordFieldCell.AllowEnter = GridStyleInfo.

            

        }
        DataTable GetTable()
        {
            DataTable dt = new DataTable();
            for (int i = 0; i < 5; i++)
                dt.Columns.Add("Column" + i);

            for (int j = 0; j < 5; j++)
            {
                DataRow row = dt.NewRow();
                for (int i = 0; i < 5; i++)
                    row[i] = "Cell" + j + "," + i;
                dt.Rows.Add(row);
            }
            dt.AcceptChanges();
            return dt;
        }
        
        #endregion


        private void btnOK_Click(object sender, EventArgs e)
        {
            int numberOfTries = 3;
            int iCounter = 0;
            while (true)
            {
                try
                {
                    StringBuilder sb = new StringBuilder();
                    if (this.rdbRule.Checked)      { sb = CollectUserActions(0); }
                    else if (rdbPortfolio.Checked) { sb = CollectUserActions(1); }
                    else if (rdbClassic.Checked)   { sb = CollectUserActions(2);
                    }

                    this.RuleCheckUpdateExceptions(this.RuleCheckID, sb.ToString());
                    //Read Final Dispositions before closing UI
                    DataSet ds = this.RuleCheckGetFinalDisposition(this.RuleCheckID); 
                    
                    FinalDispositionEventArgs myArgs = new FinalDispositionEventArgs(ds.GetXml(), this.RuleCheckID);
                    FinalDispositionEvent(this, myArgs);
                    //Close the dialog
                    this.FinalDispositions = "ds.GetXml()";
                    this.Close();
                    break;
                }catch (Exception ex)
                {
                    if (ex.Message.IndexOf("Session has expired") != -1 && iCounter < numberOfTries)
                    {
                        EventArgs eventArgs = new EventArgs();
                        MoxyTicketExiredEvent(this, eventArgs);
                        iCounter++;
                    }else
                        throw ex;
                }
            }
            

        }

    private StringBuilder CollectUserActions(int iMode)
    {

        StringBuilder sb = new StringBuilder("'<ExceptionActions>");
        foreach (Record var in this.gridRuleAlerts.GetTable("ExceptionTable").Records)
        {
            string ExceptionID = "ExceptionID=\"" + var.GetValue("exceptionID").ToString() + "\" ";
            string ActionTypeID = "ActionTypeID=\"" + var.GetValue("Action").ToString()+ "\" ";
            string ReasonID     = "ReasonID=\"" +  var.GetValue("Reason").ToString() + "\" ";
            //TODO: fix comment field
            string Comments = "Comments=\"" + "Blah Blah" + "\" ";  //var.GetValue("Comments").ToString() + "\" ";

            sb.Append("<ExceptionAction " + ExceptionID + ActionTypeID + ReasonID +  Comments + "/>");
        }
        sb.Append("</ExceptionActions>'");
        return sb;
    }


        private void gridRuleAlerts_TableControlCurrentCellControlDoubleClick(object sender, GridTableControlControlEventArgs e)
        {

            frmComment commentForm = new frmComment();
            commentForm.Comment = e.Inner.Control.Text;
            commentForm.ShowDialog();
            e.Inner.Control.Text = commentForm.Comment;
        }

        private void gridRuleAlerts_SelectRecordChanged(object sender, SelectedRecordsChangedEventArgs e)
        {
            System.Diagnostics.Debug.Write("");
        }

        private void gridRuleAlert_TableControlCurrentCellChanged(object sender, GridTableControlEventArgs e)
        {
            System.Diagnostics.Debug.Write("");
        }

        private void gridRuleAlert_CurrentCellCloseDropDown(object sender, GridTableControlPopupClosedEventArgs e)
        {
            
            //if(e.TableControl.Model.CurrentCellInfo.GridView.Name.Equals("RuleTable"))
            //    System.Diagnostics.Debug.Write("");

            /*
             * e.TableControl.Table.CurrentRecord.GetValue("RuleID")
             * 
             * */
        }

        private void gridRuleAlert_lCurrentCellChanged(object sender, GridTableControlEventArgs e)
        {
            System.Diagnostics.Debug.Write("");
        }

        private void rdbRule_CheckedChanged(object sender, EventArgs e)
        {
            if (((System.Windows.Forms.RadioButton)sender).Checked)
                PopulateGrid_RuleView(this.RuleCheckID);
        }

        private void rdbPortfolio_CheckedChanged(object sender, EventArgs e)
        {
            if (((System.Windows.Forms.RadioButton)sender).Checked)
                PopulateGrid_PortView(this.RuleCheckID);
        }

        private void rdbClassic_CheckedChanged(object sender, EventArgs e)
        {
            if (((System.Windows.Forms.RadioButton)sender).Checked)
                PopulateGrid_ClassicView(this.RuleCheckID);
        }

        private void cmdCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        
        
        
        //private void gridRuleAlerts_TableControlCellButtonClicked(object sender, GridTableControlCellButtonClickedEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlCellCancelMode(object sender, GridTableControlCellMouseEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlCellClick(object sender, GridTableControlCellClickEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlCellCursor(object sender, GridTableControlCellCursorEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlCellDoubleClick(object sender, GridTableControlCellClickEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlCellDrawn(object sender, GridTableControlDrawCellEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlCellHitTest(object sender, GridTableControlCellHitTestEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlCellMouseDown(object sender, GridTableControlCellMouseEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlCellMouseHover(object sender, GridTableControlCellMouseEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlCellMouseHoverEnter(object sender, GridTableControlCellMouseEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlCellMouseHoverLeave(object sender, GridTableControlCellMouseEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlCellMouseMove(object sender, GridTableControlCellMouseEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlCellMouseUp(object sender, GridTableControlCellMouseEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlCheckBoxClick(object sender, GridTableControlCellClickEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlCurrentCellAcceptedChanges(object sender, GridTableControlCancelEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlCurrentCellActivated(object sender, GridTableControlEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlCurrentCellActivateFailed(object sender, GridTableControlCurrentCellActivateFailedEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlCurrentCellActivating(object sender, GridTableControlCurrentCellActivatingEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlCurrentCellChanging(object sender, GridTableControlCancelEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlCurrentCellConfirmChangesFailed(object sender, GridTableControlEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlCurrentCellControlGotFocus(object sender, GridTableControlControlEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlCurrentCellControlKeyMessage(object sender, GridTableControlCurrentCellControlKeyMessageEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlCurrentCellControlLostFocus(object sender, GridTableControlControlEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlCurrentCellDeactivated(object sender, GridTableControlCurrentCellDeactivatedEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlCurrentCellDeactivateFailed(object sender, GridTableControlEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlCurrentCellDeactivating(object sender, GridTableControlCancelEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlCurrentCellDeleting(object sender, GridTableControlCancelEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlCurrentCellEditingComplete(object sender, GridTableControlEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlCurrentCellErrorMessage(object sender, GridTableControlCurrentCellErrorMessageEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlCurrentCellInitializeControlText(object sender, GridTableControlCurrentCellInitializeControlTextEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlCurrentCellKeyDown(object sender, GridTableControlKeyEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlCurrentCellKeyPress(object sender, GridTableControlKeyPressEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlCurrentCellKeyUp(object sender, GridTableControlKeyEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlCurrentCellMoved(object sender, GridTableControlCurrentCellMovedEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlCurrentCellMoveFailed(object sender, GridTableControlCurrentCellMoveFailedEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlCurrentCellMoving(object sender, GridTableControlCurrentCellMovingEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlCurrentCellRejectedChanges(object sender, GridTableControlEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlCurrentCellShowedDropDown(object sender, GridTableControlEventArgs e)
        //{

        //}

        private void gridRuleAlerts_TableControlCurrentCellShowingDropDown(object sender, GridTableControlCurrentCellShowingDropDownEventArgs e)
        {

            ////int myColIndex = ((Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl)(sender)).TableControl.CurrentCell.myColIndex;
            //string tableName = ((GridTableControlCurrentCellShowingDropDownEventArgs)e).TableControl.Table.CurrentRecord.ParentChildTable.Name;
            //int myColIndex = e.TableControl.TableDescriptor.ColIndexToField(e.TableControl.CurrentCell.ColIndex);
            //string colName = e.TableControl.TableDescriptor.VisibleColumns[myColIndex].Name;
            //if (colName.Equals("Action"))
            //{
            //    string filerValue = "RuleID = '" + e.TableControl.Table.CurrentRecord.GetValue("_ruleID").ToString() + "'";
            //    dvActions.RowFilter = filerValue;
            //}
            GridCurrentCell cc = e.TableControl.CurrentCell;
            GridTableCellStyleInfo style = e.TableControl.GetTableViewStyleInfo(cc.RowIndex, cc.ColIndex);
            if (style.TableCellIdentity.Column != null
                && style.TableCellIdentity.Column.Name == "Action")
            //&& style.TableCellIdentity.TableCellType == GridTableCellType.AnyRecordFieldCell)
            {
                style.CellType = "ComboBox";
                style.DisplayMember = "Name";
                style.ValueMember = "Key";
                //string filerValue = "RuleID = '" + e.TableControl.Table.CurrentRecord.GetValue("_ruleID").ToString() + "'";

                //DataTable dt = GetActionListFromRule(e.TableControl.Table.CurrentRecord.GetValue("ruleID").ToString());
                DataTable dt = GetActionListFromRule("161");
                //DataTable paramTable = tblParameters.Copy();
                style.DataSource = dt; //GetParameterList(paramTable);

            }


        }

        private DataTable GetActionListFromRule(string RuleID)
        {
            DataSet ds = new DataSet();
            ds.ReadXml("actions.xml");
            
            DataTable dt = new DataTable("Action");
            dt.Columns.Add(new DataColumn("RuleID"));
            dt.Columns.Add(new DataColumn("Key"));
            dt.Columns.Add(new DataColumn("Name"));
            string[] dr ={ "", "", "" };
            foreach (DataRow row in ds.Tables[0].Rows)
            {
                if (row[0].ToString().Equals(RuleID))
                {
                    dr[0] = row[0].ToString();
                    dr[1] = row[1].ToString();
                    dr[2] = row[2].ToString();
                    dt.Rows.Add(dr);
                }
            }

            return dt;
        }


        //private void gridRuleAlerts_TableControlCurrentCellStartEditing(object sender, GridTableControlCancelEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlCurrentCellValidated(object sender, GridTableControlEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlCurrentCellValidateString(object sender, GridTableControlCurrentCellValidateStringEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlCurrentCellValidating(object sender, GridTableControlCancelEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlDrawCell(object sender, GridTableControlDrawCellEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlDrawCellBackground(object sender, GridTableControlDrawCellBackgroundEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlDrawCellButton(object sender, GridTableControlDrawCellButtonEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlDrawCellDisplayText(object sender, GridTableControlDrawCellDisplayTextEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlDrawCellFrameAppearance(object sender, GridTableControlDrawCellBackgroundEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlDrawCurrentCellBorder(object sender, GridTableControlDrawCurrentCellBorderEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlHScrollPixelPosChanged(object sender, GridTableControlScrollPositionChangedEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlHScrollPixelPosChanging(object sender, GridTableControlScrollPositionChangingEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlKeyDown(object sender, GridTableControlKeyEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlKeyPress(object sender, GridTableControlKeyPressEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlKeyUp(object sender, GridTableControlKeyEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlLeftColChanged(object sender, GridTableControlRowColIndexChangedEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlLeftColChanging(object sender, GridTableControlRowColIndexChangingEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlMouseDown(object sender, GridTableControlMouseEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlMouseWheel(object sender, GridTableControlMouseEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlMoveCurrentCellDirection(object sender, GridTableControlMoveCurrentCellDirectionEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlPrepareViewStyleInfo(object sender, GridTableControlPrepareViewStyleInfoEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlPushButtonClick(object sender, GridTableControlCellPushButtonClickEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlQueryAllowArrowKeyNavigateTo(object sender, GridQueryAllowArrowKeyNavigateToEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlQueryAllowDragColumn(object sender, GridQueryAllowDragColumnEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlQueryAllowGroupByColumn(object sender, GridQueryAllowGroupByColumnEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlQueryAllowSortColumn(object sender, GridQueryAllowSortColumnEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlQueryNextCurrentCellPosition(object sender, GridTableControlQueryNextCurrentCellPositionEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlQueryScrollCellInView(object sender, GridTableControlQueryScrollCellInViewEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlResizingColumns(object sender, GridTableControlResizingColumnsEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlResizingRows(object sender, GridTableControlResizingRowsEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlScrollTipFeedback(object sender, GridTableControlScrollTipFeedbackEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlTopRowChanged(object sender, GridTableControlRowColIndexChangedEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlTopRowChanging(object sender, GridTableControlRowColIndexChangingEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlVScrollPixelPosChanged(object sender, GridTableControlScrollPositionChangedEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlVScrollPixelPosChanging(object sender, GridTableControlScrollPositionChangingEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableControlWrapCellNextControlInForm(object sender, GridTableControlWrapCellNextControlInFormEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_VisibleChanged(object sender, EventArgs e)
        //{

        //}

        //private void gridRuleAlerts_Validating(object sender, CancelEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_Validated(object sender, EventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TextChanged(object sender, EventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TabStopChanged(object sender, EventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TableSourceListChanged(object sender, TableEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_BindingContextChanged(object sender, EventArgs e)
        //{

        //}

        //private void gridRuleAlerts_CategorizedRecords(object sender, TableEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_CategorizingRecords(object sender, TableEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_CausesValidationChanged(object sender, EventArgs e)
        //{

        //}

        //private void gridRuleAlerts_ChangeUICues(object sender, UICuesEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_Click(object sender, EventArgs e)
        //{

        //}

        //private void gridRuleAlerts_ClientSizeChanged(object sender, EventArgs e)
        //{

        //}

        //private void gridRuleAlerts_ContextMenuStripChanged(object sender, EventArgs e)
        //{

        //}

        //private void gridRuleAlerts_ControlAdded(object sender, ControlEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_ControlRemoved(object sender, ControlEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_CurrentRecordContextChange(object sender, CurrentRecordContextChangeEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_CurrentRecordManagerReset(object sender, TableEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_CursorChanged(object sender, EventArgs e)
        //{

        //}

        //private void gridRuleAlerts_DisplayElementChanged(object sender, DisplayElementChangedEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_DisplayElementChanging(object sender, DisplayElementChangingEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_DockChanged(object sender, EventArgs e)
        //{

        //}

        //private void gridRuleAlerts_DoubleClick(object sender, EventArgs e)
        //{

        //}

        //private void gridRuleAlerts_DragDrop(object sender, DragEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_GroupAdded(object sender, GroupEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_GroupCollapsed(object sender, GroupEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_GroupCollapsing(object sender, GroupEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_GroupExpanded(object sender, GroupEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_GroupExpanding(object sender, GroupEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_GroupRemoving(object sender, GroupEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_KeyDown(object sender, KeyEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_KeyPress(object sender, KeyPressEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_KeyUp(object sender, KeyEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_Layout(object sender, LayoutEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_Leave(object sender, EventArgs e)
        //{

        //}

        //private void gridRuleAlerts_LocationChanged(object sender, EventArgs e)
        //{

        //}

        //private void gridRuleAlerts_MarginChanged(object sender, EventArgs e)
        //{

        //}

        //private void gridRuleAlerts_MouseCaptureChanged(object sender, EventArgs e)
        //{

        //}

        //private void gridRuleAlerts_MouseClick(object sender, MouseEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_MouseDoubleClick(object sender, MouseEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_QueryCellFormattedText(object sender, GridCellTextEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_QueryCellText(object sender, GridCellTextEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_QueryContinueDrag(object sender, QueryContinueDragEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_RecordCollapsed(object sender, RecordEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_RecordCollapsing(object sender, RecordEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_RecordDeleted(object sender, RecordEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_RecordExpanded(object sender, RecordEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_RecordExpanding(object sender, RecordEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_RecordValueChanged(object sender, RecordValueChangedEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_RecordValueChanging(object sender, RecordValueChangingEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_SaveCellFormattedText(object sender, GridCellTextEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_SaveCellText(object sender, GridCellTextEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_SaveValue(object sender, FieldValueEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_SelectedRecordsChanging(object sender, SelectedRecordsChangedEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_SortedItemsInGroup(object sender, GroupEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_SourceListListChanged(object sender, TableListChangedEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_SourceListListChangedCompleted(object sender, TableListChangedEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_SourceListRecordChanged(object sender, RecordChangedEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_SourceListRecordChanging(object sender, RecordChangedEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_TabIndexChanged(object sender, EventArgs e)
        //{

        //}

        //private void gridRuleAlerts_QueryValue(object sender, FieldValueEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_QueryRecordMeetsFilterCriteria(object sender, QueryRecordMeetsFilterCriteriaEventArgs e)
        //{

        //}

        //private void gridRuleAlerts_QueryCoveredRange(object sender, GridTableQueryCoveredRangeEventArgs e)
        //{

        //}
    }
	
}
