using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Text;
using System.Windows.Forms;





namespace MoxyRuleAlert
{
    public partial class MoxyApp : Form
    {

        Advent.MxRules.Win.ExternalClient.frmRuleAlert ruleAlert;
        string server = ""; 
        string database = ""; //
        string userId = "";
        string password = "";

        public MoxyApp()
        {
            InitializeComponent();
            ruleAlert = new Advent.MxRules.Win.ExternalClient.frmRuleAlert();
            ruleAlert.MoxyTicketExiredEvent += new Advent.MxRules.Win.ExternalClient.frmRuleAlert.FireMoxyTicketExiredEventHandler(ruleAlert_MoxyTicketExiredEvent);
            ruleAlert.Init("http://" + server, "MxRulesWeb");

        }


        private byte[] GetOneTimeAuthToken()
        {
            byte[] AuthTicket ={ 121};
            //DbConnection conn = DbHelper.GetConnection(server, database, userId, password);

            //try
            //{
            //    StoredProcWithParameters spCall = new StoredProcWithParameters("xr.pGetOneTimeAuthTicket");

            //    spCall.AddParameter("@AuthTicketOutput", null, SqlDbType.VarBinary, 500, ParameterDirection.Output);
            //    conn.Execute(spCall);
            //    AuthTicket = (byte[])(spCall.GetParameterValue("@AuthTicketOutput"));

                return AuthTicket;
            //}
            //catch (Exception ex)
            //{
            //    throw ExceptionManager.CreateMxrException(ex);
            //}
        }




        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            Application.Run(new MoxyApp());
        }

        /// <summary>
        /// This event is fired when user clicks OK on the Rule Alert dialog
        /// </summary>
        private void ruleAlert_FinalDispositionEvent(object sender, Advent.MxRules.Win.ExternalClient.FinalDispositionEventArgs e)
        {
            this.lblRuleCheckID.Text = "RuleCheckID =" + e.RuleCheckID.ToString();
            this.lblFinalDisp.Text = "Final Disposition: \n\r" + e.FinalDisposition;
        }
        private void ruleAlert_MoxyTicketExiredEvent(object sender, EventArgs e)
        {
            ruleAlert.ResetMoxyToken(GetOneTimeAuthToken());
        }

        private void cmdRuleCheckExec_Click(object sender, EventArgs e)
        {
            try
            {            
            this.lblRuleCheckID.Text = "";
            this.lblFinalDisp.Text = "";

            //if (this.chkMaxUseKey.Checked)
            //    this.txtUseKey.Text = GetMaxUseKey().ToString();

            
            //int _UseKey = Convert.ToInt16(this.txtUseKey.Text);
            int _RequestingAppID = 1;
            int _WorkEventID = 2;
            
            //int rc = ruleAlert.RunRuleCheckExecMoxy(_UseKey, _RequestingAppID, _WorkEventID);
            
            //Register event 
            ruleAlert.FinalDispositionEvent += new Advent.MxRules.Win.ExternalClient.frmRuleAlert.FireFDEventHandler(ruleAlert_FinalDispositionEvent);
            
            //This will execute CheckProposedTrades method and will load data into the dialog
            //if (rc!=0)ruleAlert.ShowDialog();

            //We have two options: use events or class properties to receive data
            string myFinalDispositions = ruleAlert.FinalDispositions;
            int myValue = ruleAlert.RuleCheckID;
            this.lblRuleCheckID.Text = ruleAlert.outPutString;


            }
            catch (Exception ex)
            {
                this.lblFinalDisp.Text = ex.Message;
            }
        }
        
        private void cmdLaunchAlerts_Click(object sender, EventArgs e)
        {

            try
            {
                this.lblRuleCheckID.Text = "";
                this.lblFinalDisp.Text = "";

                //if (this.chkMaxRuleCheckID.Checked)
                //    this.txtRuleCheckID.Text = GetMaxRuleCheckID().ToString();

                ruleAlert.PopulateGrid(Convert.ToInt16(this.txtRuleCheckID.Text));

                //Register event 
                ruleAlert.FinalDispositionEvent += new Advent.MxRules.Win.ExternalClient.frmRuleAlert.FireFDEventHandler(ruleAlert_FinalDispositionEvent);
                //ruleAlert.MoxyTicketExiredEvent += new Advent.MxRules.Win.ExternalClient.frmRuleAlert.FireMoxyTicketExiredEventHandler(ruleAlert_MoxyTicketExiredEvent);            
                //This will execute CheckProposedTrades method and will load data into the dialog
                ruleAlert.ShowDialog();
                
                //We have two options: use events or class properties to receive data
                string myFinalDispositions = ruleAlert.FinalDispositions;
                int myValue = ruleAlert.RuleCheckID;
                this.lblRuleCheckID.Text = ruleAlert.outPutString;

            }
            catch (Exception ex)
            {

                this.lblFinalDisp.Text = ex.Message;
            }
        }


        private int GetMaxUseKey()
        {
            DataSet ds = GetDataSet("select Max(UseKey) as UseKey from tempdb.dbo.mxrestriTransaction");
            int useKey = Convert.ToInt32(ds.Tables[0].Rows[0]["UseKey"]);
            return useKey;
        }

        private int GetMaxRuleCheckID()
        {
            DataSet ds = GetDataSet("select Max(RuleCheckID) as RuleCheckID from xr.RuleCheck");
            int ruleCheckID = Convert.ToInt32(ds.Tables[0].Rows[0]["RuleCheckID"]);
            return ruleCheckID;
        }

        private DataSet GetDataSet(string SQL)
        {
            string connString = "Server=" + server + "; Database=" + database + "; Integrated Security=false; User ID=" + userId + "; Password=" + password;
            DataSet dataSet = new DataSet();
            using (SqlConnection connection = new SqlConnection(connString))
            {
                connection.Open();
                SqlDataAdapter adapter = new SqlDataAdapter();
                // A table mapping names the DataTable.
                //adapter.TableMappings.Add("Table", tableName);
                // Create a SqlCommand to retrieve Suppliers data.
                SqlCommand command = new SqlCommand(SQL, connection);
                command.CommandType = CommandType.Text;
                //command.CommandTimeout = TIME_OUT;
                // Set the SqlDataAdapter's SelectCommand.
                adapter.SelectCommand = command;
                adapter.Fill(dataSet);
                connection.Close();
            }
            return dataSet;

        }
    }
}